// AjustDlg.cpp : implementation file
//________________________________________
#include "stdafx.h"
#include "Bk.h"
#include "AjustDlg.h"
#include "BkDoc.h"
#include "BkView.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CAjustDlg dialog
CAjustDlg::CAjustDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAjustDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAjustDlg)
	m_sG = _T("");
	m_sI = _T("");
	//}}AFX_DATA_INIT
}
void CAjustDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAjustDlg)
	DDX_Control(pDX, IDC_SLIDERI, m_sliderI);
	DDX_Control(pDX, IDC_SLIDERG, m_sliderG);
	DDX_Text(pDX, IDC_STATICG, m_sG);
	DDX_Text(pDX, IDC_STATICI, m_sI);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAjustDlg, CDialog)
	//{{AFX_MSG_MAP(CAjustDlg)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDORI, OnOri)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CAjustDlg message handlers
BOOL CAjustDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	//Pointeur sur l'application
	m_pApp=((CBkApp*)AfxGetApp());
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur le document
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	//Pointeur sur la vue
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	//Affectation des composantes de l'image
	GetSize(m_pDoc->image,&m_L,&m_H,&m_channels);
	w_R=new unsigned char[m_L*m_H];
	w_G=new unsigned char[m_L*m_H];
	w_B=new unsigned char[m_L*m_H];
	//Image originale
	copy_image(m_pDoc->image,&imageOri);
	//Dfinition des plages des sliders
	m_sliderI.SetRange(0,100);//-50, 50
	m_sliderG.SetRange(1,200);//0.01, 2

	m_sliderI.SetPos(50);//0
	m_sliderG.SetPos(100);//1

	m_iIt=m_sliderI.GetPos()-50;
	m_fGt=0.01*m_sliderG.GetPos();

	m_sI.Format("Luminance [-50,50]: %d",m_iIt);
	m_sG.Format("Gamma [0.01, 2]: %4.2f",m_fGt);
	UpdateData(FALSE);
	m_iNb=0;m_OK=FALSE;/*m_s4="";*/SetTimer(27,50,NULL);
	return TRUE;
}
//________________________________________
void CAjustDlg::PostNcDestroy() 
{
	delete w_R;
	delete w_G;
	delete w_B;
	CDialog::PostNcDestroy();
}
//________________________________________
void CAjustDlg::GetPixelColor(Hobject image,unsigned char *wR,unsigned char *wG,unsigned char *wB) 
{
	short i,j;
	long l,h,channels;
	char lpcsType[128];
	unsigned char 
		*R,*V,*B;

	count_channels(image,&channels);
	if (channels==1) 
	{
		get_image_pointer1(image,(long*)&R,lpcsType,&l,&h);
		for (i=0;i<l;i++)
		{
			for (j=0;j<h;j++)
			{
				wR[i+j*l]=*(R+i+j*l);
				wG[i+j*l]=*(R+i+j*l);
				wB[i+j*l]=*(R+i+j*l);
			}
		}
	}
	else
	{
		get_image_pointer3(image,(long*)&R,(long*)&V,(long*)&B,lpcsType,&l,&h);
		for (i=0;i<l;i++)
		{
			for (j=0;j<h;j++)
			{
				wR[i+j*l]=*(R+i+j*l);
				wG[i+j*l]=*(V+i+j*l);
				wB[i+j*l]=*(B+i+j*l);
			}
		}
	}
}
//________________________________________
void CAjustDlg::SetPixelColor(long l,long h,unsigned char *wR,unsigned char *wG,unsigned char *wB,Hobject *image) 
{
	long channels;
	count_channels(*image,&channels);
	if (channels==1) 
		gen_image1(image,"byte",l,h,(long)wR);
	else
		gen_image3(image,"byte",l,h,(long)wR,(long)wG,(long)wB);
}
//________________________________________
void CAjustDlg::GetSize(Hobject image,long *L,long *H,long *channels)
{
	char lpcsType[128];
	unsigned char 
		*R,*V,*B;

	count_channels(image,channels);
	if (*channels==1) 
		get_image_pointer1(image,(long*)&R,lpcsType,L,H);
	else
		get_image_pointer3(image,(long*)&R,(long*)&V,(long*)&B,lpcsType,L,H);
}
//________________________________________
void CAjustDlg::Visualiser() 
{
	copy_image(imageOri,&(m_pDoc->image));
	GetPixelColor(m_pDoc->image,w_R,w_G,w_B);
	//Changement de luminance
	changebright(m_iIt,m_L,m_H,w_R,w_G,w_B);
	//Changement de facteur gamma
	gammabrighten(m_fGt,m_L,m_H,w_R,w_G,w_B);
	SetPixelColor(m_L,m_H,w_R,w_G,w_B,&(m_pDoc->image));
	m_pView->Invalidate(TRUE);
}
//________________________________________
void CAjustDlg::changebright(short w,long l,long h,unsigned char *wR,unsigned char *wG,unsigned char *wB)
{
	short i,j;
	short W;
	for (i=0;i<l;i++)
	{
		for (j=0;j<h;j++)
		{
			W=wR[i+j*l]+w;
			if (W<0) W=0;
			if (W>255) W=255;
			wR[i+j*l]=W;
			W=wG[i+j*l]+w;
			if (W<0) W=0;
			if (W>255) W=255;
			wG[i+j*l]=W;
			W=wB[i+j*l]+w;
			if (W<0) W=0;
			if (W>255) W=255;
			wB[i+j*l]=W;
		}
	}
}
//________________________________________
void CAjustDlg::gammabrighten(float gamma,long l,long h,unsigned char *wR,unsigned char *wG,unsigned char *wB) 
{
	//AfxMessageBox("ici");
	short i,j;
	short W;
	float r;
	for (i=0;i<l;i++)
	{
		for (j=0;j<h;j++)
		{
			r=255.0*pow((1.0*wR[i+j*l]/255.0),gamma);
			if (r<0) r=0;
			if (r>255) r=255;
			W=(unsigned char)r;
			wR[i+j*l]=W;
			r=255.0*pow((1.0*wG[i+j*l]/255.0),gamma);
			if (r<0) r=0;
			if (r>255) r=255;
			W=(unsigned char)r;
			wG[i+j*l]=W;
			r=255.0*pow((1.0*wB[i+j*l]/255.0),gamma);
			if (r<0) r=0;
			if (r>255) r=255;
			W=(unsigned char)r;
			wB[i+j*l]=W;
		}
	}
}
//________________________________________
void CAjustDlg::OnCancel() 
{
	KillTimer(27);
	copy_image(imageOri,&(m_pDoc->image));
	CDialog::OnCancel();
}
//________________________________________
void CAjustDlg::OnOK() 
{
	KillTimer(27);
	CDialog::OnOK();
}
//________________________________________
void CAjustDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	m_iIt=m_sliderI.GetPos()-50;
	m_fGt=0.01*m_sliderG.GetPos();
	m_sI.Format("Luminance [-50,50]: %d",m_iIt);
	m_sG.Format("Gamma [0.01, 2]: %4.2f",m_fGt);
	UpdateData(FALSE);
	//Visualiser();
	m_iNb=0;m_OK=TRUE;//m_s4="";
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
//________________________________________
void CAjustDlg::OnOri() 
{
	m_sliderI.SetPos(50);//0
	m_sliderG.SetPos(100);//1
	m_iIt=m_sliderI.GetPos()-50;
	m_fGt=0.01*m_sliderG.GetPos();
	m_sI.Format("Luminance [-50,50]: %d",m_iIt);
	m_sG.Format("Gamma [0.01, 2]: %4.2f",m_fGt);
	UpdateData(FALSE);
	Visualiser();
	
}
/*
//________________________________________
void CAjustDlg::OnAppliquer1() 
{
	Visualiser();
}
*/
//________________________________________
void CAjustDlg::OnTimer(UINT nIDEvent) 
{
	//Mise  jour automatique au bout de __ s aprs dplacement slider
	m_iNb++;
	if (m_iNb>10 && m_OK==TRUE)
	{
		//Mise  jour
		m_OK=FALSE;
		Visualiser();
		m_pDoc->UpdateAllViews(NULL);
		//m_s4="*";
		//UpdateData(FALSE);
	}	
	CDialog::OnTimer(nIDEvent);
}
