// Bk.cpp : Defines the class behaviors for the application.
#include "stdafx.h"
#include "Bk.h"
#include "MainFrm.h"
#include "ChildFrm.h"
#include "BkDoc.h"
#include "BkView.h"
#include "MatroxOrion.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CBkApp
BEGIN_MESSAGE_MAP(CBkApp, CWinApp)
	//{{AFX_MSG_MAP(CBkApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()
//________________________________________
// CBkApp construction
CBkApp::CBkApp()
{
	m_iNo=0;	//N de la premire image ouverte
	m_iNb=0;	//Nb. de fentres ouvertes
	//Paramtres des outils de dessin_______
	m_iEpais=1;										//Epaisseur des traits
	m_iHaut=14;										//Hauteur des textes
	couleur[0]=RGB(255,255,255);
	couleur[1]=RGB(255,0,0);			//Marque de digitalisation
	couleur[2]=RGB(255,255,0);		//Segment profil
	couleur[3]=RGB(255,130,255);	//Profil H
	couleur[4]=RGB(130,255,130);	//Profil V
	couleur[5]=RGB(80,80,230);		//Cotation
	couleur[6]=RGB(255,0,255);		//Annotation
	couleur[7]=RGB(0,0,0);				//Tracker
	DefinirOutils();
	//Image  copier________________________
	m_pDocACopier=NULL;
	pDocGrab=NULL;
	//Botes de dialogue non modales________
	m_pCodeDlg=NULL;
	m_pExtractDlg=NULL;
	m_pCoordDlg=NULL;
	//Forme du tracker______________________
	m_radioTypeTracker=0;
	//Carte Orion
	m_pOrion=new CMatroxOrion();
	//Lecteur Leuze
	m_radioCom=0;
}
//________________________________________
// The one and only CBkApp object
CBkApp theApp;

//________________________________________
// CBkApp initialization
BOOL CBkApp::InitInstance()
{
	// Standard initialization

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register document templates

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_BKTYPE,
		RUNTIME_CLASS(CBkDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CBkView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;


	//Exportation vers Excel...
	//IMPORTANT: Voir ProfilDlg.cpp et stdafx.h
	if (!AfxOleInit())
	{
		
		AfxMessageBox("Erreur d'initialisation de AfxDao !");
		return FALSE;
	}
	//Taille demi-cran
	CRect r;
	pMainFrame->GetWindowRect(r);
	m_sizeFen=r.Size();
	//Taille maxi des fentres
	m_iLmax=1024;
	m_iHmax=768;
	m_iLfen=m_sizeFen.cx/2-20;
	m_iHfen=480*m_iLfen/640;

	//Carte par dfaut
	m_iCarte=0;//Aucune

	//Rsolutions disponibles pour les diffrents numriseurs
	AffecteResolutions(m_iCarte);
	//Taille par dfaut de la fentre, 1re ligne du tableau m_sResolTab
	m_iTaille=0;
	Largeur_x_Hauteur(m_iTaille,&m_iL,&m_iH);

	//Camra mvBlueFox
	m_fGain=15.0;
	m_iShutter=20000;
	//______________________________________
	char buf[512];
	CFile f;
	CFileException e;
	char* pFileName = "config.dat";
	//Lecture du fichier de configuration
	if( !f.Open( pFileName, CFile::modeRead,&e))
	{
		//AfxMessageBox("Erreur d'ouverture du fichier config.dat\nValeurs par dfaut utilises...");
	}
	else
	{
		CArchive ar(&f,CArchive::load,512,buf);
		Lire_Ecrire(ar);
	}
	f.Close();
	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}
//________________________________________
int CBkApp::ExitInstance() 
{
	char buf[512];
	CFile f;
	CFileException e;
	char* pFileName="config.dat";
	if(!f.Open( pFileName, CFile::modeCreate | CFile::modeWrite, &e ) )
	{
		//AfxMessageBox("Erreur d'criture du fichier config.dat");
	}
	else
	{
		CArchive ar(&f,CArchive::store,512,buf);
		Lire_Ecrire(ar);
	}
	f.Close();
	//Carte Orion
	delete m_pOrion;
	return CWinApp::ExitInstance();
}
//________________________________________
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CListBox	m_Liste;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_LISTE, m_Liste);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CBkApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}
//________________________________________
// CBkApp commands
void CBkApp::Lire_Ecrire(CArchive& ar)
{
	//Fichier de configuration config.dat
	short i=0;
	float r=0.0;
	if (ar.IsStoring())
	{
		//Oprations de sauvegarde
		ar<<(short)m_iCarte;           
		ar<<(short)m_iL;           
		ar<<(short)m_iH;
		ar<<(short)m_iTaille;
		ar<<(short)i;
		ar<<(short)i;
		ar<<(short)i;
		ar<<(short)i;
		ar<<(short)i;
		ar<<(short)i;
		ar<<r;
		ar<<r;
		ar<<r;
		ar<<r;
		ar<<r;
		ar<<r;
		ar<<r;
		ar<<r;
		ar<<r;
		ar<<r;
		ar<<r;
	}
	else
	{
		//Oprations de lecture
		ar>>(short)m_iCarte;           
		ar>>(short)m_iL;
		ar>>(short)m_iH;
		ar>>(short)m_iTaille;
		ar>>(short)i;
		ar>>(short)i;
		ar>>(short)i;
		ar>>(short)i;
		ar>>(short)i;
		ar>>(short)i;
		ar>>r;
		ar>>r;
		ar>>r;
		ar>>r;
		ar>>r;
		ar>>r;
		ar>>r;
		ar>>r;
		ar>>r;
		ar>>r;
		ar>>r;
	}
}
//________________________________________
void CBkApp::AffecteResolutions(short carte)
{
	short i;
	for (i=0;i<10;i++)
	{
		m_iLH[i][0]=m_iLH[i][1]=0;
	}
	CString z;z.Format("%dx%d",m_iLfen,m_iHfen);
	//Attention, 10 lignes maxi (i<10)
	switch (carte)
	{
		case 0://Aucune
			m_iLH[0][0]=m_iLfen;m_iLH[0][1]=m_iHfen;
			m_iLH[1][0]=320;    m_iLH[1][1]=240;
			m_iLH[2][0]=512;    m_iLH[2][1]=512;
			m_iLH[3][0]=640;    m_iLH[3][1]=480;
			m_iLH[4][0]=768;    m_iLH[4][1]=576;
			m_iLH[5][0]=800;    m_iLH[5][1]=600;
			m_iLH[6][0]=1024;   m_iLH[6][1]=768;
			m_iLH[7][0]=1280;   m_iLH[7][1]=1024;
		break;
		case 1://Twain
			m_iLH[0][0]=320;    m_iLH[0][1]=240;
		break;
		case 2://Webcam(Video for Windows)
			m_iLH[0][0]=m_iLfen;m_iLH[0][1]=m_iHfen;
			m_iLH[1][0]=320;    m_iLH[1][1]=240;
			m_iLH[2][0]=512;    m_iLH[2][1]=512;
			m_iLH[3][0]=640;    m_iLH[3][1]=480;
			m_iLH[4][0]=768;    m_iLH[4][1]=576;
			m_iLH[5][0]=800;    m_iLH[5][1]=600;
			m_iLH[6][0]=1024;   m_iLH[6][1]=768;
			m_iLH[7][0]=1280;   m_iLH[7][1]=1024;
		break;
		case 3://Webcam(Direct Show)
			m_iLH[0][0]=640;    m_iLH[0][1]=480;
			m_iLH[1][0]=320;    m_iLH[1][1]=240;
		break;
		case 4://Meteor II
			m_iLH[0][0]=768;    m_iLH[0][1]=576;
		break;
		case 5://IEEE
			m_iLH[0][0]=640;    m_iLH[0][1]=480;
			m_iLH[1][0]=800;    m_iLH[1][1]=600;
			m_iLH[2][0]=1024;   m_iLH[2][1]=768;
		break;
		case 6://blueFox 102C ou 102G
			m_iLH[0][0]=m_iLfen;m_iLH[0][1]=m_iHfen;
			m_iLH[1][0]=320;    m_iLH[1][1]=240;
			m_iLH[2][0]=640;    m_iLH[2][1]=480;
			m_iLH[3][0]=768;    m_iLH[3][1]=576;
			m_iLH[4][0]=800;    m_iLH[4][1]=600;
			m_iLH[5][0]=1024;   m_iLH[5][1]=768;
			m_iLH[6][0]=1280;   m_iLH[6][1]=1024;
		break;
		case 7://blueFox 120C ou 120G
			m_iLH[0][0]=640;    m_iLH[0][1]=480;
			m_iLH[1][0]=m_iLfen;m_iLH[1][1]=m_iHfen;
			m_iLH[2][0]=320;    m_iLH[2][1]=240;
			m_iLH[3][0]=768;    m_iLH[3][1]=576;
			m_iLH[4][0]=800;    m_iLH[4][1]=600;
			m_iLH[5][0]=1024;   m_iLH[5][1]=768;
			m_iLH[6][0]=1280;   m_iLH[6][1]=1024;
		break;
		case 8://Orion
			m_iLH[0][0]=768;    m_iLH[0][1]=576;
		break;
	}
}
//________________________________________
BOOL CBkApp::VerifResol(short carte,short l,short h)
{
	//On regarde si l et h sont permis pour le numriseur
	short i;
	BOOL ok=FALSE;
	i=0;
	do
	{
		if (m_iLH[i][0]==l && m_iLH[i][1]==h) ok=TRUE;
		i++;
	}
	while (ok==FALSE && i<10);
	//Si non, on prend la premire taille possible
	if (ok==FALSE) m_iTaille=0;
	return ok;
}
//________________________________________
short CBkApp::Largeur_x_Hauteur(short i,short *L,short *H)
{
	short err;
	if (i<0 || i>9)
	{
		err=1;
		*L=640;*H=480;
	}
	else
	{
		if (m_iLH[i][0]<=0 || m_iLH[i][1]<=0)
		{
			err=1;
			*L=640;*H=480;
		}
		else
		{
			err=0;
			*L=m_iLH[i][0];
			*H=m_iLH[i][1];
		}
	}
	return err;
}
//________________________________________
void CBkApp::DefinirOutils(void)
{
	//Outils de dessin______________________
	short i;
	for (i=0;i<8;i++)
	{
		//pinceau[i].CreateSolidBrush(couleur[i]);
		if (i==7)
			//Tracker, non paramtrable
			plume[i].CreatePen(PS_DOT,0,couleur[i]);
		else
			plume[i].CreatePen(PS_SOLID,m_iEpais,couleur[i]);
	}
	
	ZeroMemory(&lf,sizeof(LOGFONT));
	lstrcpy(lf.lfFaceName,"Arial");
	lf.lfHeight=m_iHaut;
	//Cration de 180 fontes inclines
	for (i=-90;i<90;i++)
	{
		lf.lfEscapement=-10*i;
		fonteC[i+90].CreateFontIndirect(&lf);
	}
}
//________________________________________
void CBkApp::EffacerOutils(void)
{
	short i;
	for (i=0;i<8;i++)
	{
		//pinceau[i].DeleteObject();
		plume[i].DeleteObject();
	}
	for (i=0;i<180;i++) fonteC[i].DeleteObject();
}
//________________________________________
BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_Liste.AddString("20/07/07: Nouvel icne");
	m_Liste.AddString("07/12/06: Carte Matrox Orion");
	m_Liste.AddString("20/11/06: Fichier config.dat");
	m_Liste.AddString("10/11/06: Beep pour codes lus CCD");
	m_Liste.AddString("07/11/06: Optimisation affichage codes lus");
	m_Liste.AddString("03/11/06: Modification des paramtres du code");
	m_Liste.AddString("02/11/06: Extraction code  la vole dans image");
	m_Liste.AddString("01/11/06: Cration du logiciel");
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CBkApp::FermerFenetre(CBkDoc *pDoc)
{
	CBkDoc *p[20];
	GetDocument(p);
	for (short i=0;i<20;i++)
	{
		if (p[i]==pDoc)
		{
			AfxGetApp()->m_pMainWnd->SendMessage(WM_COMMAND,ID_FILE_CLOSE,0);
			i=20;
		}
	}
}
//________________________________________
CBkDoc* CBkApp::CreerNouvelleFenetre(short l,short h)
{
	CBkDoc *pDoc;
	CMDIChildWnd *pChild;
	//L'image phase existe maintenant.
	AfxGetApp()->m_pMainWnd->SendMessage(WM_COMMAND,ID_FILE_NEW,0);
	pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	pDoc=(CBkDoc*)pChild->GetActiveDocument();
	if (l>100 && h>100) pDoc->DimensionnerFenetre(l,h);
	return pDoc;
}
//________________________________________
void CBkApp::GetDocument(CBkDoc *p[20])
{
	short i;
	CBkDoc *pDoc=NULL;
	CMDIChildWnd *pChild;
	for (i=0;i<20;i++) p[i]=NULL;
	if(AfxGetApp()->m_pMainWnd)
	{
		pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument();
		if (pDoc!=NULL)
		{
			i=0;
			p[i]=pDoc;
			do
			{
				i++;
				((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDINext();
				pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
				if (pChild && i<20)
				{
					pDoc=(CBkDoc*)pChild->GetActiveDocument();
					if (pDoc!=p[0]) p[i]=pDoc;
				}
			}
			while (p[0]!=pDoc);
		}
	}
}
//________________________________________
void CBkApp::GetDocumentSansCourant(CBkDoc *p[20])
{
	short i;
	CBkDoc *pDoc=NULL,*pAct=NULL;
	CMDIChildWnd *pChild;
	for (i=0;i<20;i++) p[i]=NULL;
	if(AfxGetApp()->m_pMainWnd)
	{
		pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) pAct=(CBkDoc*)pChild->GetActiveDocument();
		if (pAct!=NULL)
		{
			i=0;
			do
			{
				((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDINext();
				pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
				if (pChild && i<20)
				{
					pDoc=(CBkDoc*)pChild->GetActiveDocument();
					if (pDoc!=pAct) p[i]=pDoc;
				}
				i++;
			}
			while (pAct!=pDoc);
		}
	}
}
//________________________________________
void CBkApp::Cascade(void)
{
	short i;
	CBkDoc *p,*pDoc=NULL;
	CMDIChildWnd *pChild;
	if(AfxGetApp()->m_pMainWnd)
	{
		//Cascade les images
		AfxGetApp()->m_pMainWnd->SendMessage(WM_COMMAND,ID_WINDOW_CASCADE,0);
		//Dimensionne les images
		pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument();
		if (pDoc!=NULL)
		{
			i=0;
			p=pDoc;
			p->DimensionnerFenetre(p->m_iL,p->m_iH);
			do
			{
				i++;
				((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDINext();
				pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
				if (pChild)
				{
					pDoc=(CBkDoc*)pChild->GetActiveDocument();
					if (pDoc!=p)
					{ 
						pDoc->DimensionnerFenetre(pDoc->m_iL,pDoc->m_iH);
					}
				}
			}
			while (p!=pDoc);
		}
	}
}
