// BkDoc.cpp : implementation of the CBkDoc class
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "BkView.h"
#include "math.h"
#include "geoana.h"
#include "webcam.h"
#include "code.h"
#include "MatroxOrion.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CBkDoc
IMPLEMENT_DYNCREATE(CBkDoc, CDocument)

BEGIN_MESSAGE_MAP(CBkDoc, CDocument)
	//{{AFX_MSG_MAP(CBkDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CBkDoc construction/destruction
CBkDoc::CBkDoc()
{
	m_pApp=((CBkApp*)AfxGetApp());
	m_pWnd=NULL;				//Pointeur sur la fentre affect dans CBkView::OnInitialUpdate
	m_pView=NULL;				//Pointeur sur la vue affect dans CBkView::OnInitialUpdate
	m_iNo=m_pApp->m_iNo;
	m_pApp->m_iNb++;
	m_sNomFic.Format("Image%d",m_iNo);
	m_pApp->m_iNo++;
	//Tailles
	m_iL=m_pApp->m_iL;
	m_iH=m_pApp->m_iH;

	m_iXpos=m_iYpos=0;		//Barres de dfilement
	//Coordonnes souris____________________
	m_iX=m_iY=0;				//Coordonnes absolues
	m_iW=0;
	m_iDx=m_iDy=0;			//Coordonnes relatives
	m_iDw=-1;
	//Echelles
	m_fEchXY=1.0f;
	m_fFactXY=1.0f;
	m_OKXY=FALSE;
	//Profil________________________________
	m_p.radioComposante=0,//0:R ou NG pour image monochrome, 1:V, 2:B, 3:NG pour image couleur
	m_p.iX1=-1;						//Positions de trac du profil
	m_p.iY1=-1;
	m_p.iX2=-1;
	m_p.iY2=-1;
  //Donnes (profil,...)__________________
	m_iNbMax=800;				//Nb. maxi de donnes
  m_iNb=0;						//Aucune donne pour l'instant
  m_fT=new float[m_iNbMax][6];
	if (AfxCheckMemory()==FALSE) AfxMessageBox("Erreur test mmoire dans fonction CBkDoc::CBkDoc");;
	//Gaussienne
	m_OKGauss=FALSE;
	//Type de visualisation
	m_iType=0;					//Bit0: 
											//Bit1: Trac dans Excel
											//Bit2: Trac de profils
	//Couleur du code
	m_lCB=RGB(10,10,127);
	//m_lCB=254;
	//m_lCE=254 + 127*256 + 127*65536;
	m_lCE=255 + 255*256 + 255*65536;

	//Nouvelle image________________________
	short i,j;
	unsigned char w,*R,*G,*B;
	if (m_pApp->m_iCarte==0)
	{
		//Pas de numriseur
		/*
		R=new unsigned char[m_iL*m_iH];
		G=new unsigned char[m_iL*m_iH];
		B=new unsigned char[m_iL*m_iH];
		for (i=0;i<m_iL;i++)
		{
			w=(unsigned char)255.0*i/m_iL;
			for (j=0;j<m_iH;j++)
			{
				//R[i+j*m_iL]=w; 
				//G[i+j*m_iL]=(unsigned char)255.0*j/m_iH; 
				//B[i+j*m_iL]=255-w; 
				R[i+j*m_iL]=m_lCE&255; 
				G[i+j*m_iL]=(m_lCE/256)&255;
				B[i+j*m_iL]=(m_lCE/65536)&255; 
			}
		}
		gen_image3(&image,"byte",m_iL,m_iH,(long)R,(long)G,(long)B);
		delete R;delete G;delete B;
		*/
		/**/
		R=new unsigned char[m_iL*m_iH];
		for (i=0;i<m_iL;i++)
		{
			w=(unsigned char)255;
			for (j=0;j<m_iH;j++)
			{
				R[i+j*m_iL]=w; 
			}
		}
		gen_image1(&image,"byte",m_iL,m_iH,(long)R);
		delete R;
		/**/
	}
	else
		gen_image_const(&image,"byte",m_iL,m_iH);

	//Code barre par dfaut
	//m_sCode="0027131006534";	//Parfum Knowing
	//m_sCode="0028941648327";	//CD Mozart
	//m_sCode="3048431001545";	//Vittel
	//m_sCode="3414090816491";	//Dodorant
	//m_sCode="3278940919974";	//Protge slip
	//m_sCode="3527360009759";	//CD RW
	//m_sCode="3428271930050";	//Lait 1l
	//m_sCode="3365000005316";	//Starwax vitres
	//m_sCode="4005808650002";	//Stick  lvres
	//m_sCode="4007817504598";	//Gomme
	//m_sCode="4015400021155";	//Couches Frdric
	//m_sCode="5410673004208";	//Riz Oncle Benz
	//m_sCode="5099703981421";	//CD Beethoven
	//m_sCode="8076802085837";	//Ptes Barilla
	m_sCode="7610810992322";	//Dissolvant
	CCode *pCode;
	pCode=new CCode(this);
	pCode->Couleur(m_lCB,m_lCE);
	pCode->TraceCode(7,60,m_sCode);
	delete pCode;
}
//________________________________________
CBkDoc::~CBkDoc()
{
	m_pApp->pDocGrab=NULL;
	close_all_framegrabbers();
	m_pApp->m_iNb--;
	delete[] m_fT;
}
//________________________________________
BOOL CBkDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	return TRUE;
}
//________________________________________
// CBkDoc serialization
void CBkDoc::Serialize(CArchive& ar)
{
	short i,err;
	CString s,s1;
	CFile *fp=ar.GetFile();
	s=s1=fp->GetFilePath();
	s1.MakeUpper();
	set_check("~give_error");
	if (ar.IsStoring())
	{
		//ECRITURE
		if ((m_iType&8)!=0 || (m_iType&16)!=0)
		{
			//Image complexe (FFT...)
			AfxMessageBox("Image FFT, sauvegarde impossible !\nLa convertir pralablement en nuances de gris...");
		}
		else
		{
			if (s1.Find(".TIF")!=-1)
			{
				fp->Close();
				err=write_image(image,"tiff",0,s);
				if (err!=2) AfxMessageBox("Erreur d'criture de l'image !");

				fp->Open(s,CFile::modeWrite);	
				m_pApp->AddToRecentFileList(s);
			}
			else
			if (s1.Find(".JPG")!=-1)
			{
				fp->Close();
				err=write_image(image,"jpeg30",0,s);
				if (err!=2) AfxMessageBox("Erreur d'criture de l'image !");
				fp->Open(s,CFile::modeWrite);	
				m_pApp->AddToRecentFileList(s);
			}
			else
			//if (s1.Find(".")!=-1)
			{
				//Ajout extension .tif
				s=s+".tif";
				fp->Close();
				err=write_image(image,"tiff",0,s);
				if (err!=2) AfxMessageBox("Erreur d'criture de l'image !");
				fp->Open(s,CFile::modeWrite);	
			}
			/*
			else
			{

				AfxMessageBox("Extension du fichier non reconnue !");
				//AfxMessageBox(s1);
			}
			*/
			//Enlever les chemins
			i=s.ReverseFind('\\');
			if (i>1) s=s.Right(s.GetLength()-i-1);
			m_sNomFic.Format("%s",s);
			EcritTitre();
		}
	}
	else
	{
		//LECTURE
		fp->Close();
		err=read_image(&image,s);
		long l,h,nb;
		count_channels(image,&nb);
		char lpcsType[128];
		unsigned char *R,*G,*B;
		if (nb==1) 
			err=get_image_pointer1(image,(long*)&R,lpcsType,&l,&h);
		else
			err=get_image_pointer3(image,(long*)&R,(long*)&G,(long*)&B,lpcsType,&l,&h);
		fp->Open(s,CFile::modeRead);	
		m_iL=(short)l;m_iH=(short)h;
		m_pApp->AddToRecentFileList(s);
		//Enlever les chemins
		i=s.ReverseFind('\\');
		if (i>1) s=s.Right(s.GetLength()-i-1);
		m_sNomFic.Format("%s",s);
		EcritTitre();
		m_iType=0;
	}
	set_check("give_error");
}
//______________________________________
void CBkDoc::LitImage(CArchive& ar)
{
	short l,h;
	Serialize(ar);
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			m_pView=(CBkView*)pChild->GetActiveView();
			m_pWnd=m_pView->GetParent();
			if (m_iL<m_pApp->m_iLmax)
				l=m_iL;
			else
				l=m_pApp->m_iLmax;
			if (m_iH<m_pApp->m_iHmax)
				h=m_iH;
			else
				h=m_pApp->m_iLmax;
			m_pView->SetScrollSizes(MM_TEXT, CSize(m_iL,m_iH));
			DimensionnerFenetre(l,h);
			set_window_extents(m_pView->m_lWindowID,0,0,m_iL,m_iH);
		}
	}
}
//________________________________________
// CBkDoc diagnostics
#ifdef _DEBUG
void CBkDoc::AssertValid() const
{
	CDocument::AssertValid();
}
//________________________________________
void CBkDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG
//________________________________________
// CBkDoc commands
void CBkDoc::DimensionnerFenetre(short l,short h)
{
	if (l>m_pApp->m_iLmax) l=m_pApp->m_iLmax;
	if (h>m_pApp->m_iHmax) h=m_pApp->m_iHmax;
	
	CRect	 MMRect,MMRect1,MMRect2;
	int l1,h1,l2,h2;
	m_pWnd->GetWindowRect(MMRect1);
	m_pWnd->GetClientRect(MMRect2);
	l1=MMRect1.right-MMRect1.left;
	h1=MMRect1.bottom-MMRect1.top;
	l2=MMRect2.right-MMRect2.left;
	h2=MMRect2.bottom-MMRect2.top;
	MMRect.SetRect(0,0,l+l1-l2+4,h+h1-h2+4);
	MMRect.OffsetRect(-MMRect.left,-MMRect.top);
	m_pWnd->SetWindowPos(NULL,l1,h1,MMRect.right,MMRect.bottom,SWP_NOACTIVATE|SWP_NOZORDER|SWP_NOMOVE|SWP_DRAWFRAME);
	m_pWnd->InvalidateRect(NULL,FALSE);
}
//________________________________________
void CBkDoc::EcritTitre(void)
{
	CString s;
	short x;
	if (GetPathName().GetLength()==0)
	{
	}
	else
	{
		//GetTitle ne renvoie pas l'extension...
		if (m_sNomFic.GetLength()==0) m_sNomFic=GetPathName();
		//On enlve le chemin pour ne garder que le nom du fichier avec extension
		x=m_sNomFic.ReverseFind('\\');
		if (x>=0)	m_sNomFic=m_sNomFic.Right(m_sNomFic.GetLength()-x-1);
	}
	s.Format("%s (%dx%d)",m_sNomFic,m_iL,m_iH);
	SetTitle(s);
}
//________________________________________
void CBkDoc::LimiterTailleFenetre(short l,short h)
{
	//Limite la taille de la fentre  l x h si elle est plus grande
	CRect	 MMRect,MMRect1,MMRect2;
	long l1,h1,l2,h2;
	if (m_pWnd!=NULL)
	{
		m_pWnd->GetWindowRect(MMRect1);
		m_pWnd->GetClientRect(MMRect2);
		l1=MMRect1.right-MMRect1.left;
		h1=MMRect1.bottom-MMRect1.top;
		l2=MMRect2.right-MMRect2.left;
		h2=MMRect2.bottom-MMRect2.top;

		if (l1>l || h1>h)
		{
			MMRect.SetRect(0,0,l+l1-l2+4,h+h1-h2+4);
			MMRect.OffsetRect(-MMRect.left,-MMRect.top);
			m_pWnd->SetWindowPos(NULL,l1,h1,MMRect.right,MMRect.bottom,SWP_NOACTIVATE|SWP_NOZORDER|SWP_NOMOVE|SWP_DRAWFRAME);
			m_pWnd->InvalidateRect(NULL,FALSE);
		}
	}
}
//________________________________________
void CBkDoc::DefinirCurseurs(short l,short h)
{
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			CBkView *pView;
			pView=(CBkView*)pChild->GetActiveView();
			pView->SetScrollSizes(MM_TEXT, CSize(l,h));
			pView->ScrollToPosition(CPoint(0,0));
			m_iXpos=pView->GetScrollPos(SB_HORZ);
			m_iYpos=pView->GetScrollPos(SB_VERT);
		}
	}
}
//________________________________________
void CBkDoc::setpixelcolor(Hobject hoImage,short i,short j,long w) 
{
	Hobject m_Ired,m_Igreen,m_Iblue;
	long wR,wG,wB,channels;
	count_channels(image,&channels);
	if (channels==3)
	{
		access_channel(image,&m_Ired,1); 
		access_channel(image,&m_Igreen,2); 
		access_channel(image,&m_Iblue,3); 
	}
	else
		access_channel(image,&m_Ired,1); 
	if (channels==1)
	{
		w=w&255;
		set_grayval(m_Ired,j,i,w);

	}
	else
	{
		wR=w&255;
		set_grayval(m_Ired,j,i,wR);
		wG=(w/256)&255;
		set_grayval(m_Igreen,j,i,wG);
		wB=(w/65536)&255;
		set_grayval(m_Iblue,j,i,wB);
	}
}
//________________________________________
long CBkDoc::getpixelcolor(Hobject hoImage,short i,short j) 
{
	//Hobject m_Ired,m_Igreen,m_Iblue;
	long 
		w=-1,
		w1,w2,w3,
		L,H,
		channels;
	double r1,r2,r3;
	count_channels(hoImage,&channels);
	char lpcsType[128];
	unsigned char *R,*G,*B;
	if (channels==1) 
	{
		get_image_pointer1(hoImage,(long*)&R,lpcsType,&L,&H);
		if (i>=0 && i<L && j>=0 && j<H)
		{
			w=R[i+j*L];
			/*
			access_channel(hoImage,&m_Ired,1); 
			get_grayval(m_Ired,j,i,&r1);w1=(long)r1;
			w=w1&255;
			*/
		}
	}
	else
	if (channels==3)
	{
		get_image_pointer3(hoImage,(long*)&R,(long*)&G,(long*)&B,lpcsType,&L,&H);
		if (i>=0 && i<L && j>=0 && j<H)
		{
			w1=R[i+j*L];
			w2=G[i+j*L];
			w3=B[i+j*L];
			/*
			access_channel(hoImage,&m_Ired,1); 
			access_channel(hoImage,&m_Igreen,2); 
			access_channel(hoImage,&m_Iblue,3); 
			get_grayval(m_Ired,j,i,&r1);w1=(long)r1;
			w1=w1&255;
			get_grayval(m_Igreen,j,i,&r2);w2=(long)r2;
			w2=w2&255;
			get_grayval(m_Iblue,j,i,&r3);w3=(long)r3;
			w3=w3&255;
			*/
			w=w1+256*w2+256*256*w3;
		}
	}
	return w;
}
//________________________________________
//Calcul des fonctions profils et gaussiennes et affectation m_fT
void CBkDoc::CalculProfils(short no_composante,short X1,short Y1,short X2,short Y2)
{
	short 
		x1,y1,x2,y2,
		i,nb,l,h,k;
	float 
		a,b,
		x,y,
		*t,sig,vc;
		//PI=4*atan(1);
	long w;
	t=new float[m_iNbMax];
	class CGeoAna geo;
	//Initialisation tableau m_fT document destination
	for (l=0;l<m_iNbMax;l++)
	{
		for (h=0;h<6;h++) m_fT[l][h]=1e10;
	}

	if (X1<X2)
	{
		x1=X1;x2=X2;
	}
	else
	{
		x1=X2;x2=X1;
	}
	if (Y1<Y2)
	{
		y1=Y1;y2=Y2;
	}
	else
	{
		y1=Y2;y2=Y1;
	}
	geo.d2p(X1,Y1,X2,Y2,&a,&b);
	//Profil H____________________________
	k=0;
	for (l=x1;l<x2;l++)
	{
		geo.p2d(X1,Y1,a,l,0,PI/2,&x,&y);
		if (k<m_iNbMax && x!=1e10 && y!=1e10 && x>=0 && x<m_iL && y>=0 && y<m_iH)
		{
			w=getpixelcolor(image,l,(short)(y));
			w=composante(w,no_composante);
			m_fT[k][0]=l;
			m_fT[k][1]=w;
			if (k<1024)
			{
				t[k]=(float)w;
				k++;
			}
		}
	}
	//Gauss H_____________________________
	nb=k;
	sig=sigma(t,nb);
	vc=val_cen(t,nb);
	if (vc==1e10)
		vc=127;
	else
		vc=vc+x1;
	//Maxi
	w=0;
	for (i=0;i<nb;i++)
	{
		if (i<m_iNbMax)
		{
			if (t[i]>w) w=(int)t[i];
		}
	}
	k=0;     
	for (l=x1;l<x2;l++)
	{
		if (k<m_iNbMax)
		{
			m_fT[k][2]=1.0*w*gauss(l,vc,sig);
			k++;
		}
	}
	//Profil V____________________________
	k=0;
	for (h=y1;h<y2;h++)
	{
		geo.p2d(X1,Y1,a,0,h,0,&x,&y);
		if (k<m_iNbMax && x!=1e10 && y!=1e10 && x>=0 && x<m_iL && y>=0 && y<m_iH)
		{
			w=getpixelcolor(image,(short)(x),h);
			w=composante(w,no_composante);
			m_fT[k][3]=w;
			m_fT[k][4]=h;
			t[k]=(float)w;
			k++;
		}
	}	
	//Gauss V_____________________________
	nb=k;
	sig=sigma(t,nb);
	vc=val_cen(t,nb);
	if (vc==1e10)
		vc=127;
	else
		vc=vc+y1;
	//Maxi
	w=0;
	for (i=0;i<nb;i++)
	{
		if (i<m_iNbMax)
		{
			if (t[i]>w) w=(int)t[i];
		}
	}
	k=0;     
	for (h=y1;h<y2;h++)
	{
		if (k<m_iNbMax)
		{
			m_fT[k][5]=1.0*w*gauss(h,vc,sig);
		}
		k++;
	}
	m_iNb=m_iNbMax;
	delete[] t;
}
//________________________________________
long CBkDoc::composante(long w,short no_composante)
{
	long w1;
	unsigned short r,v,b;
	switch (no_composante)
	{
		case 0://Composante rouge
			w1=w&255;
		break;
		case 1://Composante verte
			w1=(w/256)&255;
		break;
		case 2://Composante bleue
			w1=(w/65536)&255;
		break;
		case 3://Conversion NG
			r=w&255;
			v=(w/256)&255;
			b=(w/65536)&255;
			w1=(30*r+59*v+11*b)/100;
		break;
	}
	return w1;
}
//________________________________________
float CBkDoc::gauss(float p,float p0,float sigma)
{
	return (float)(exp(-pow(p-p0,2)/(2*pow(sigma,2))));
}
//________________________________________
float CBkDoc::val_cen(float t[1024],unsigned int n)
{
	float s=0,s1=0;
	int w;
	if (n==0) return 1e10;
	if (n>1024) n=1024;
	for (w=0;w<n;w++)
	{
		s=s+t[w]*(w+1);
		s1=s1+t[w];
	}
	if (fabs(s1)>1e-6) return s/s1; else return 1e10;
}
//________________________________________
float CBkDoc::sigma(float t[1024],unsigned int n)
{
	float r=0,s=0,s1=0,moy=0;
	int w;
	if (n==0) return 1e10;
	if (n>1024) n=1024;

	for (w=0;w<n;w++)
	{
		s=s+t[w]*(w+1);
		s1=s1+t[w];
	}
	moy=s/s1;
	for (w=0;w<n;w++)
	{
		r=r+pow(moy-(w+1),2)*t[w];
	}
	return (float)(pow(r/s1,0.5));
}
//________________________________________
void CBkDoc::InitTracker(void)
{                       
	m_tracker.m_rect.SetRectEmpty();
	m_tracker.m_nStyle=m_tracker.dottedLine;
	m_tracker.m_nHandleSize=8;
}
//________________________________________
short CBkDoc::AcqPerm() 
{
	Herror err;
	CString CameraType;
	char message[MAX_STRING];

	m_pApp=((CBkApp*)AfxGetApp());
	m_iType=0;
	set_check("~give_error");
	close_all_framegrabbers();
	VerifAjustTailleFen(m_pApp->m_iCarte);
	switch (m_pApp->m_iCarte)
	{
		case 0://Pas de carte
		break;
		case 1://TWAIN
			m_pApp->pDocGrab=this;
			err=open_framegrabber("TWAIN",1,1,0,0,0,0,"default",-1,"default",-1,"default","interactive:inches","interactive",-1,1,&m_lFGHandle);
			//err=open_framegrabber("TWAIN",-1,-1,-1,-1,-1,-1,"default",-1,"default",-1,"default","pixels","default",-1,1,&m_lFGHandle);
			if (err!=2)
			{
				//get_error_text((long)err,message);AfxMessageBox(message);
			}
			else
			{
				grab_image(&image,m_lFGHandle);
				long l,h,nb;
				count_channels(image,&nb);
				char lpcsType[128];
				unsigned char *R,*G,*B;
				if (nb==1) 
					get_image_pointer1(image,(long*)&R,lpcsType,&l,&h);
				else
					get_image_pointer3(image,(long*)&R,(long*)&G,(long*)&B,lpcsType,&l,&h);
				//CString z;z.Format("%d,%d",l,h);AfxMessageBox(z);
				m_iL=l;m_iH=h;
				set_window_extents(m_pView->m_lWindowID,0,0,m_iL,m_iH);
				m_pView->SetScrollSizes(MM_TEXT, CSize(m_iL,m_iH));
				EcritTitre();
				m_iType=0;
				DimensionnerFenetre(l,h);
				close_framegrabber(m_lFGHandle);
			}
			m_pApp->pDocGrab=NULL;
		break;
		case 2://Camra USB avec video for windows
			m_pWeb=new CWebCam(m_iL,m_iH);
			if (m_pWeb->Connexion(m_pView->m_HWND)==FALSE)
			{
				m_pApp->m_iCarte=0;
				AfxMessageBox("Camra USB Video for Windows non trouve !");
			}
			else
			{
				m_pApp->m_iCarte=2;
				m_pApp->pDocGrab=this;
				m_pWeb->AfficheWebCam();
			}
		break;
		case 3://Camra USB avec direct show
			CameraType.Format("PAL RGB24 (%dx%d)",m_iL,m_iH);//640x480 ou 320x240 
			//CameraType.Format("RGB24 (%dx%d)",m_iL,m_iH);//640x480 ou 320x240 
		  err=open_framegrabber("DirectShow",1,1,0,0,0,0,"default",-1,/*"gray"*//*"default"*/"rgb",-1,"false",CameraType,"0",-1,-1,&m_lFGHandle);
			if (err!=2)
			{
				m_pApp->m_iCarte=0;
				//get_error_text((long)err,message);AfxMessageBox(message);
				AfxMessageBox("Camra USB Direct Show non trouve !");
			}
			else
			{
				//Grab gr par CBkView::OnTimer
				//set_framegrabber_param(m_lFGHandle,"color_enable","on");
				set_part(m_pView->m_lWindowID,0,0,m_pApp->m_iH,m_pApp->m_iL);
				//grab_image(&(image),m_lFGHandle);
				//grab_image_start(m_lFGHandle,-1.0);
				m_pView->GrabContinu(this);
			}
		break;
		case 4://Matrox Meteor
			err=open_framegrabber("MeteorII",1,1,0,0,0,0,"default",-1,"default",-1,"false","M_CCIR","METEOR_II:0",-1,1,&m_lFGHandle);
			if (err!=2)
			{
				m_pApp->m_iCarte=0;
				//get_error_text((long)err,message);AfxMessageBox(message);
				AfxMessageBox("Carte Matrox MeteorII non trouve !");
			}
			else
			{
				//Grab gr par CBkView::OnTimer
				set_part(m_pView->m_lWindowID,0,0,m_pApp->m_iH,m_pApp->m_iL);
				m_pView->GrabContinu(this);
			}
		break;
		case 5://FireWire IEEE 1394
			if (m_pApp->m_iL==640)
				err=open_framegrabber(HTuple("1394IIDC"),HTuple(1),HTuple(1),HTuple(0),HTuple(0),HTuple(0),HTuple(0),HTuple("default"),HTuple(-1),HTuple("default"),HTuple(-1),HTuple("default"),HTuple("0:5:4"),HTuple("default"),HTuple(-1),HTuple(-1),&m_lFGHandle);
			else
			if (m_pApp->m_iL==800)
				err=open_framegrabber(HTuple("1394IIDC"),HTuple(1),HTuple(1),HTuple(0),HTuple(0),HTuple(0),HTuple(0),HTuple("default"),HTuple(-1),HTuple("default"),HTuple(-1),HTuple("default"),HTuple("1:2:2"),HTuple("default"),HTuple(-1),HTuple(-1),&m_lFGHandle);
			else
			if (m_pApp->m_iL==1024)
				err=open_framegrabber(HTuple("1394IIDC"),HTuple(1),HTuple(1),HTuple(0),HTuple(0),HTuple(0),HTuple(0),HTuple("default"),HTuple(-1),HTuple("default"),HTuple(-1),HTuple("default"),HTuple("1:5:4"),HTuple("default"),HTuple(-1),HTuple(-1),&m_lFGHandle);
			else
				err=open_framegrabber(HTuple("1394IIDC"),HTuple(1),HTuple(1),HTuple(0),HTuple(0),HTuple(0),HTuple(0),HTuple("default"),HTuple(-1),HTuple("default"),HTuple(-1),HTuple("default"),HTuple("default"),HTuple("default"),HTuple(-1),HTuple(-1),&m_lFGHandle);
			//err=open_framegrabber(HTuple("1394IIDC"),HTuple(1),HTuple(1),HTuple(0),HTuple(0),HTuple(0),HTuple(0),HTuple("default"),HTuple(-1),HTuple("default"),HTuple(-1),HTuple("default"),HTuple("7:0:0"),HTuple("default"),HTuple(-1),HTuple(-1),&m_lFGHandle);
			//                                       HRes      VRes      ImWidth   ImHeight  StartRow  StartColumn Ignored         BitsPerChannel ColorSpace   Gain(Ignored) ExternalTrigger CameraType        Device            Port       LineLn
			if (err!=2)
			{
				m_pApp->m_iCarte=0;
				//get_error_text((long)err,message);AfxMessageBox(message);
				AfxMessageBox("Camra Firewire sur port IEEE1394 non trouve !");
			}
			else
			{
				//Grab gr par CBkView::OnTimer
				//set_framegrabber_param(m_lFGHandle,"camera_type","Format_7");
				//set_framegrabber_param(m_lFGHandle,"image_height",m_pApp->m_iH);
				//set_framegrabber_param(m_lFGHandle,"image_width",m_pApp->m_iL);
				//set_framegrabber_param(m_lFGHandle,"vertical_resolution",m_pApp->m_iH);
				//set_framegrabber_param(m_lFGHandle,"horizontal_resolution",m_pApp->m_iL);
				/*				
				HTuple ht;
				get_framegrabber_param(m_lFGHandle,"horizontal_resolution_range",&ht);
				long ll[8];
				short i;
				for (i=0;i<4;i++)
				{
					ll[i]=ht[i];
				}
				CString z;z.Format("%d\n%d\n%d\n%d\n",ll[0],ll[1],ll[2],ll[3]);AfxMessageBox(z);
				*/
				/*			
				long L,H;
				HTuple ImageWidth,ImageHeight;
				get_framegrabber_param(m_lFGHandle,HTuple("image_width"),&ImageWidth);
				get_framegrabber_param(m_lFGHandle,HTuple("image_height"),&ImageHeight);
				L=ImageWidth[0];H=ImageHeight[0];
				CString z;z.Format("%d,%d",L,H);AfxMessageBox(z);
				*/
				set_part(m_pView->m_lWindowID,0,0,m_pApp->m_iH,m_pApp->m_iL);
				//grab_image(&(image),m_lFGHandle);
				//grab_image_start(m_lFGHandle,-1.0);
				m_pView->GrabContinu(this);
			}
		break;
		case 6://Matrix Vision mvBlueFox 102G
		  err=open_framegrabber("MatrixVisionAcquire",1,1,0,0,0,0,"default",-1,"default",m_pApp->m_fGain,"false","mvBlueFOX*","0",0,-1,&m_lFGHandle);
			if (err!=2)
			{
				m_pApp->m_iCarte=0;
				//get_error_text((long)err,message);AfxMessageBox(message);
				AfxMessageBox("Camra USB Matrix Vision mvBlueFOX non trouve sur port n0 !");
			}
			else
			{
				//Grab gr par CBkView::OnTimer
				set_framegrabber_param(m_lFGHandle,HTuple("ImageHeight"),m_pApp->m_iH);
				set_framegrabber_param(m_lFGHandle,HTuple("ImageWidth"),m_pApp->m_iL);
				set_framegrabber_param(m_lFGHandle,"Camera/Expose_us",m_pApp->m_iShutter);
				//set_framegrabber_param(m_lFGHandle,"Camera/Gain_dB",m_pApp->m_fGain);
				//Mettre la rsolution du capteur
				set_part(m_pView->m_lWindowID,0,0,1024,1280);
				m_pView->GrabContinu(this);
			}
		break;
		case 7://Matrix Vision mvBlueFox 120G ou C
		  err=open_framegrabber("MatrixVisionAcquire",1,1,0,0,0,0,"default",-1,"default",m_pApp->m_fGain,"false","mvBlueFOX*","0",0,-1,&m_lFGHandle);
			if (err!=2)
			{
				m_pApp->m_iCarte=0;
				//get_error_text((long)err,message);AfxMessageBox(message);
				AfxMessageBox("Camra USB Matrix Vision mvBlueFOX non trouve sur port n0 !");
			}
			else
			{
				//Grab gr par CBkView::OnTimer
				set_framegrabber_param(m_lFGHandle,HTuple("ImageHeight"),m_pApp->m_iH);
				set_framegrabber_param(m_lFGHandle,HTuple("ImageWidth"),m_pApp->m_iL);
				set_framegrabber_param(m_lFGHandle,"Camera/Expose_us",m_pApp->m_iShutter);
				//set_framegrabber_param(m_lFGHandle,"Camera/Gain_dB",m_pApp->m_fGain);
				//Mettre la rsolution du capteur
				set_part(m_pView->m_lWindowID,0,0,640,480);
				m_pView->GrabContinu(this);
			}
		break;
		case 8://Matrox Orion
			short err,L,H;
			CString z;
			err=m_pApp->m_pOrion->InitOrion(&L,&H);
			if (err!=0)
			{
				z.Format("Carte Matrox Orion (%dx%d) non trouve ou dj adresse !\nErreur InitOrion() n%d.",L,H,err);
				AfxMessageBox(z);
				m_pApp->m_iCarte=0;
			}
			else
			{
				//Fermer la visu Halcon pour en faire une fentre graphique normale
				close_window(m_pView->m_lWindowID);

				err=m_pApp->m_pOrion->AcqPermOrion(m_pView->m_hWnd);
				if (err==0)
				{
					m_pApp->pDocGrab=this;
					UpdateAllViews(NULL);
				}
				else
				{
					z.Format("Erreur sur fonction acquisition permanente !\nErreur AcqPermOrion() n%d.",err);
					AfxMessageBox(z);
					m_pApp->m_iCarte=0;
				}
			}
		break;
	}
	set_check("give_error");
	return m_pApp->m_iCarte;
}
//________________________________________
void CBkDoc::FigerAcq() 
{
	unsigned char *R,*G,*B;
	short 
		L=m_pApp->pDocGrab->m_iL,
		H=m_pApp->pDocGrab->m_iH;
	//CString z;z.Format("__%d,%d",H,L);AfxMessageBox(z);
	R=new unsigned char[L*H];
	G=new unsigned char[L*H];
	B=new unsigned char[L*H];
	BOOL okNB;
	switch (m_pApp->m_iCarte)
	{
		case 1://Twain : uniquement monocoup...
		break;
		case 2://Webcam avec video for windows
			//Important: m_pApp->pDocGrab est motiv par le fait que l'acq. permanente n'est pas forcment dans la fentre active
			m_pApp->pDocGrab->m_pWeb->GrabStop();
			okNB=m_pApp->pDocGrab->m_pWeb->Deconnexion(R,G,B);
			delete m_pApp->pDocGrab->m_pWeb;
			if (okNB)
				gen_image1(&(m_pApp->pDocGrab->image),"byte",L,H,(long)R);
			else
				gen_image3(&(m_pApp->pDocGrab->image),"byte",L,H,(long)R,(long)G,(long)B);
			m_pApp->pDocGrab=NULL;
		break;
		case 3://Webcam avec direct show
			m_pApp->pDocGrab->m_pView->GrabArret();
		break;
		case 4://Matrox Meteor
			m_pApp->pDocGrab->m_pView->GrabArret();
		break;
		case 5://IEEE 1394
			m_pApp->pDocGrab->m_pView->GrabArret();
		break;
		case 6://mvBlueFOX 102G ou C
			m_pApp->pDocGrab->m_pView->GrabArret();
		break;
		case 7://mvBlueFOX 120G ou C
			m_pApp->pDocGrab->m_pView->GrabArret();
		break;
		case 8://Matrox Orion
			m_pApp->m_pOrion->FigerOrion(R,G,B);
			//Ouverture d'une fentre HALCON ferme dans InitDialog (l'image redevient "normale")
			set_check("~father");
			open_window(0,0,m_iL,m_iH,(long)m_pView->m_hWnd,"visible","",&(m_pView->m_lWindowID));
			set_window_extents(m_pView->m_lWindowID,0,0,m_iL,m_iH);

			//gen_image3(&(m_pApp->pDocGrab->image),"byte",L,H,(long)R,(long)G,(long)B);
			gen_image1(&(m_pApp->pDocGrab->image),"byte",L,H,(long)R);

			m_pApp->pDocGrab=NULL;
			m_pApp->m_pOrion->LibereOrion();
			m_pView->Invalidate(FALSE);
		break;
	}
	//On ramne l'image  la taille de la fentre, important si le grab n'est pas  la taille fentre...
	zoom_image_size(image,&image,m_iL,m_iH,"constant");
	//m_pView->Invalidate(FALSE);
	delete R;delete G;delete B;
}
//_________________________________________________
void CBkDoc::VerifAjustTailleFen(short carte)
{
	BOOL ok;
	//On regarde si m_iL et m_iH sont possibles pour cette carte
	ok=m_pApp->VerifResol(carte,m_iL,m_iH);
	if (m_pApp->m_iL!=m_iL || m_pApp->m_iH!=m_iH)
	{
		m_iL=m_pApp->m_iL;m_iH=m_pApp->m_iH;
		DimensionnerFenetre(m_iL,m_iH);
		DefinirCurseurs(m_iL,m_iH);
		EcritTitre();
		set_window_extents(m_pView->m_lWindowID,0,0,m_iL,m_iH);
		gen_image_const(&image,"byte",m_iL,m_iH);
	}
}
//_________________________________________________
void CBkDoc::PositionnerFenetre(short l,short h)
{
	CRect	 MMRect,MMRect1;
	long l1,h1;
	m_pWnd->GetWindowRect(MMRect1);
	l1=MMRect1.right-MMRect1.left;
	h1=MMRect1.bottom-MMRect1.top;
	MMRect.SetRect(0,0,l1,h1);
	MMRect.OffsetRect(-MMRect.left,-MMRect.top);
	m_pWnd->SetWindowPos(NULL,l,h,MMRect.right,MMRect.bottom,SWP_NOZORDER|SWP_DRAWFRAME|SWP_SHOWWINDOW);
	m_pWnd->InvalidateRect(NULL,FALSE);
}
//_________________________________________________
void CBkDoc::OuEstLaFenetre(short *l,short *h)
{
	CRect	 MMRect1,MMRect2;
	short l1,h1,l2,h2;
	m_pWnd->GetWindowRect(MMRect1);
	m_pWnd->GetClientRect(MMRect2);
	l1=MMRect1.left;
	h1=MMRect1.top;
	l2=MMRect2.left;
	h2=MMRect2.top;
	//CString z;
	//z.Format("%d, %d\n%d,%d",l1,h1,l2,h2);AfxMessageBox(z);
	*l=l1-2;
	//*h=h1-78;
	*h=h1-72;
}
