// BkDoc.h : interface of the CBkDoc class
//Halcon
#include "HalconCPP.h"
class CBkDoc : public CDocument
{
protected: // create from serialization only
	CBkDoc();
	DECLARE_DYNCREATE(CBkDoc)

// Attributes
protected:
	class CBkApp* m_pApp;

public:
	class CWnd* m_pWnd;			//Pointeur sur la fentreafect dans CBkView::OnInitialUpdate()
	class CBkView* m_pView;	//Pointeur sur la fentreafect dans CBkView::OnInitialUpdate()
	CString m_sNomFic;
	short m_iNo;
	short 
		m_iL,m_iH,
		m_iX,m_iY,					//Absolues en pixel
		m_iDx,m_iDy,				//Relatives
		m_iXpos,m_iYpos;		//Barres de dfilement
	long m_iW,m_iDw;
	//Echelles pour calibrage________________
	float
		m_fEchXY,
		m_fFactXY;
	BOOL 
		m_OKXY;
	//Profils_______________________________
	typedef struct
	{
		short
		radioComposante,		//0:R ou NG pour image monochrome, 1:V, 2:B, 3:NG pour image couleur
		iX1,iY1,						//Position de trac du profil point 1 segment
		iX2,iY2;						//Position de trac du profil point 2 segment
	}
	profil;
	profil m_p;
  //Donnes (profil,...)__________________
	short 
		m_iNbMax,				//Nb. maxi de donnes 
		m_iNb;					//Nb. effectif de donnes
	float (*m_fT)[6];	//Pointeur sur un tableau de float  6 colonnes
	//Gaussienne
	BOOL m_OKGauss;
	//Type de visualisation
	int m_iType;
	//Tracker_______________________________
	CRectTracker m_tracker;

	//Halcon
	Hobject image;
	//Framegrabber
	long m_lFGHandle;
	//Webcam
	class CWebCam	*m_pWeb;
	//Code
	CString m_sCode;
	long m_lCE,m_lCB;

// Operations
public:
	void CalculProfils(short no_composante,short X1,short Y1,short X2,short Y2);
	long composante(long w,short no_composante);
	float gauss(float p,float p0,float sigma);
	float val_cen(float t[1024],unsigned int n);
	float sigma(float t[1024],unsigned int n);
	void DefinirCurseurs(short l,short h);
	void DimensionnerFenetre(short l,short h);
	void PositionnerFenetre(short l,short h);
	void OuEstLaFenetre(short *l,short *h);
	void EcritTitre(void);
	long getpixelcolor(Hobject hoImage,short i,short j);
	void setpixelcolor(Hobject hoImage,short i,short j,long w);
	void LimiterTailleFenetre(short l,short h);
	void InitTracker(void);
	void LitImage(CArchive& ar);
	void FigerAcq(void);
	short AcqPerm(void);
	void VerifAjustTailleFen(short carte);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBkDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBkDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBkDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//________________________________________
