// BkView.cpp : implementation of the CBkView class
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "BkView.h"
#include "Vicdefs.h"
#include "Webcam.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CBkView
IMPLEMENT_DYNCREATE(CBkView, CScrollView)

BEGIN_MESSAGE_MAP(CBkView, CScrollView)
	//{{AFX_MSG_MAP(CBkView)
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_CONTEXTMENU()
	ON_WM_LBUTTONUP()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID__GRAB,Grab)
	ON_COMMAND(ID__STOPGRAB,StopGrab)
	ON_COMMAND(ID__CUR_SOURIS,InitSouris)
	ON_COMMAND(ID__EFF__PROFILS,InitProfils)
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()
//________________________________________
// CBkView construction/destruction
CBkView::CBkView()
{
	m_pApp=((CBkApp*)AfxGetApp());

}
//________________________________________
CBkView::~CBkView()
{
}
//Menus contextuels_______________________
void CBkView::Grab()
{
	class CBkDoc *pDoc=GetDocument();
	pDoc->AcqPerm();
}
void CBkView::StopGrab()
{
	class CBkDoc *pDoc=GetDocument();
	pDoc->FigerAcq();
}
void CBkView::InitSouris()
{
	//Initialisation coordonnnes souris
	//Voir: CBkView::OnContextMenu
	//Coordonnes relatives souris
	class CBkDoc *pDoc=GetDocument();
	pDoc->m_iDx=0;
	pDoc->m_iDy=0;
	pDoc->m_iDw=-1;
	Invalidate();
}
void CBkView::InitProfils(void)
{
	class CBkDoc *pDoc=GetDocument();
	pDoc->m_iType=pDoc->m_iType^4;
	pDoc->InitTracker();
	Invalidate();
}
//________________________________________
BOOL CBkView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CScrollView::PreCreateWindow(cs);
}
//________________________________________
// CBkView drawing
void CBkView::OnDraw(CDC* pDC)
{
	CBkDoc* pDoc=GetDocument();
	m_HWND=m_hWnd;

	if(pDoc->m_iType&1)
	{
		//Visu3D : rien  faire, tout est gr dans C3dDlg
	}
	else
		if (m_pApp->pDocGrab!=pDoc)	OnTrace(pDC);
}
//________________________________________
void CBkView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
	CBkDoc* pDoc=GetDocument();
	short x,y;
	//Mmoriser le pointeur sur la fentre et la vue dans le document
	pDoc->m_pWnd=GetParent();
	if (pDoc->m_iL<=m_pApp->m_iLmax)
		x=pDoc->m_iL;
	else
		x=m_pApp->m_iLmax;
	if (pDoc->m_iH<=m_pApp->m_iHmax)
		y=pDoc->m_iH;
	else
		y=m_pApp->m_iHmax;
	SetScrollSizes(MM_TEXT, CSize(pDoc->m_iL,pDoc->m_iH));
	pDoc->DimensionnerFenetre(x,y);
	pDoc->m_pView=this;
	//Nom fentre
	pDoc->EcritTitre();
	//Halcon
	set_check("~father");
	open_window(0,0,pDoc->m_iL,pDoc->m_iH,(long)m_hWnd,"visible","",&m_lWindowID);
	set_window_extents(m_lWindowID,0,0,pDoc->m_iL,pDoc->m_iH);
}
//________________________________________
// CBkView printing
BOOL CBkView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}
//________________________________________
void CBkView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}
//________________________________________
void CBkView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}
//________________________________________
// CBkView diagnostics
#ifdef _DEBUG
void CBkView::AssertValid() const
{
	CScrollView::AssertValid();
}
//________________________________________
void CBkView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
//________________________________________
CBkDoc* CBkView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBkDoc)));
	return (CBkDoc*)m_pDocument;
}
#endif //_DEBUG
//________________________________________
// CBkView message handlers
void CBkView::OnTrace(CDC* pDC)
{
	CRect rect;
	GetClientRect(rect);  
	pDC->SetBkMode(TRANSPARENT);
	CBkDoc* pDoc=GetDocument();
	pDC->DPtoLP(rect);
	short X,Y;
	if (pDC->IsPrinting())
	{
		//Affichage image dans fonction OnPrint...
		X=pDoc->m_iDx+pDoc->m_iXpos;
		Y=pDoc->m_iDy+pDoc->m_iYpos;
		if (pDoc->m_iDx!=0 && pDoc->m_iDy!=0)	
		{
			MarqueDePointage(pDC,X,Y,1,TRUE);
		}
		if(pDoc->m_iType&4)
		{
			if (abs(pDoc->m_p.iX1-pDoc->m_p.iX2)>10 || abs(pDoc->m_p.iY1-pDoc->m_p.iY2)>10)
			{
				SegmentProfil(pDC);
				pDoc->CalculProfils(pDoc->m_p.radioComposante,pDoc->m_p.iX1,pDoc->m_p.iY1,pDoc->m_p.iX2,pDoc->m_p.iY2);
			}
			if (abs(pDoc->m_p.iX1-pDoc->m_p.iX2)>10)
			{
				ProfilH(pDC);
				if (pDoc->m_OKGauss) GaussH(pDC);
			}
			if (abs(pDoc->m_p.iY1-pDoc->m_p.iY2)>10)
			{
				ProfilV(pDC);
				if (pDoc->m_OKGauss) GaussV(pDC);
			}
		}
	}
	else
	if (m_pApp->pDocGrab!=pDoc)
	{
		//Halcon
		VisuHalcon();

		//Dclarer dc, sinon le scroll ne fonctionne pas !
		CClientDC dc(this);

		//Position souris
		X=pDoc->m_iDx;
		Y=pDoc->m_iDy;

		if (m_pApp->m_pExtractDlg!=NULL)
		{
			TraceTracker(&dc,0); //Rectangle
		}
		else
		{
			if (pDoc->m_iDx!=0 && pDoc->m_iDy!=0)	
			{
				MarqueDePointage(&dc,X,Y,1,TRUE);
			}
			TraceTracker(&dc,0); //Rectangle
			if(pDoc->m_iType&4)
			{
				if (abs(pDoc->m_p.iX1-pDoc->m_p.iX2)>10 || abs(pDoc->m_p.iY1-pDoc->m_p.iY2)>10)
				{
					SegmentProfil(&dc);
					long channels;
					count_channels(pDoc->image,&channels);
					if (channels==1) pDoc->m_p.radioComposante=0; else pDoc->m_p.radioComposante=3;
					pDoc->CalculProfils(pDoc->m_p.radioComposante,pDoc->m_p.iX1,pDoc->m_p.iY1,pDoc->m_p.iX2,pDoc->m_p.iY2);
				}
				if (abs(pDoc->m_p.iX1-pDoc->m_p.iX2)>10)
				{
					ProfilH(&dc);
					if (pDoc->m_OKGauss) GaussH(&dc);
				}
				if (abs(pDoc->m_p.iY1-pDoc->m_p.iY2)>10)
				{
					ProfilV(&dc);
					if (pDoc->m_OKGauss) GaussV(&dc);
				}
			}
		}
	}
}
//________________________________________
void CBkView::VisuHalcon(void)
{
	//Visualisation de l'image Halcon
	CBkDoc* pDoc=GetDocument();


	if ((pDoc->m_iType&1)!=1)
	{
		//CString z;
		//z.Format("%d",pDoc->m_iType);
		//AfxMessageBox(z);

		set_part(m_lWindowID,0,0,pDoc->m_iH,pDoc->m_iL);
		disp_obj(pDoc->image,m_lWindowID);
	}
}
//________________________________________
void CBkView::OnPrint(CDC* pDC,CPrintInfo * pInfo)
{
	CBkDoc* pDoc=GetDocument();
	short 
		i,j,
		l=pInfo->m_rectDraw.Width(),
		h=pInfo->m_rectDraw.Height();
	long L,H,p,w,w1,w2,w3;
	char lpcsType[128];
	HDC hDC;
	hDC=pDC->m_hDC;
	HPALETTE hpal;
	float ech;
	//On tient compte de la zone d'impression...
	
	if (1.0*l/pDoc->m_iL>1.0*h/pDoc->m_iH)
		ech=1.0f*h/pDoc->m_iH; else ech=1.0f*l/pDoc->m_iL;
	//CString z;z.Format("%d,%d,%f",l,h,ech);AfxMessageBox(z);
	//Suppression du zoom automatique d'impression sur largeur de page
	ech=ech/2.5;
	/*
	CRect MMRect1;
	pDoc->m_pWnd->GetWindowRect(MMRect1);
	short l1,h1;
	l1=MMRect1.right-MMRect1.left;
	h1=MMRect1.bottom-MMRect1.top;
	//z.Format("%d,%d",l1,h1);AfxMessageBox(z);
	*/
	pDC->SetMapMode(MM_ISOTROPIC);
	pDC->SetWindowExt(pDoc->m_iL,pDoc->m_iH);
	pDC->SetViewportExt((short)(pDoc->m_iL*ech),(short)(pDoc->m_iH*ech));

	imgdes im;
	unsigned char 
		*m_R,*m_G,*m_B,
		*wR,*wG,*wB;
	long channels;

	L=pDoc->m_iL;
	H=pDoc->m_iH;

	m_R=new unsigned char[L*H];
	m_G=new unsigned char[L*H];
	m_B=new unsigned char[L*H];

	count_channels(pDoc->image,&channels);
	allocimage(&im,L,H,channels*8);
	if (channels==3)
	{
		get_image_pointer3(pDoc->image,(long*)&wR,(long*)&wG,(long*)&wB,lpcsType,&L,&H);
		for (p=0;p<L*H;p++)
		{
			m_R[p]=*(wR+p);
			m_G[p]=*(wG+p);
			m_B[p]=*(wB+p);
		}
	}
	else
	{
		get_image_pointer1(pDoc->image,(long*)&wR,lpcsType,&L,&H);
		for (p=0;p<L*H;p++)	m_R[p]=*(wR+p);
	}
	for (i=0;i<L;i++)
	{
		for (j=0;j<H;j++)
		{
			if (channels==1)
			{
				w=m_R[i+j*L]&255;
			}
			else
			{
				w1=m_R[i+j*L];
				w1=w1&255;
				w2=m_G[i+j*L];
				w2=w2&255;
				w3=m_B[i+j*L];
				w3=w3&255;
				w=w1+256*w2+256*256*w3;
			}
			setpixelcolor(&im,i,j,w);
		}
	}
	viewimage(m_hWnd,hDC,&hpal,0,0,&im);
	freeimage(&im);
	//On trace le reste de la visualisation...
	OnTrace(pDC);
	delete m_R;delete m_G;delete m_B;
}
//________________________________________
void CBkView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CBkDoc* pDoc=GetDocument();
	pDoc->m_iXpos=GetScrollPos(SB_HORZ);
	pDoc->m_iYpos=GetScrollPos(SB_VERT);
	pDoc->InitTracker();
	CScrollView::OnHScroll(nSBCode, nPos, pScrollBar);
}
//________________________________________
void CBkView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CBkDoc* pDoc=GetDocument();
	pDoc->m_iXpos=GetScrollPos(SB_HORZ);
	pDoc->m_iYpos=GetScrollPos(SB_VERT);
	pDoc->InitTracker();
	CScrollView::OnVScroll(nSBCode, nPos, pScrollBar);
}
//________________________________________
void CBkView::OnSize(UINT nType, int cx, int cy) 
{
	CBkDoc* pDoc=GetDocument();
	pDoc->m_iXpos=GetScrollPos(SB_HORZ);
	pDoc->m_iYpos=GetScrollPos(SB_VERT);
	pDoc->InitTracker();
	CScrollView::OnSize(nType,cx,cy);
}
//________________________________________
void CBkView::CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType) 
{
	CBkDoc* pDoc=GetDocument();
	long x,y;
	x=lpClientRect->right-lpClientRect->left;
	y=lpClientRect->bottom-lpClientRect->top;
	//Si la taille de la fentre est plus grande que l'image, on la limite
	if (x>pDoc->m_iL && y>pDoc->m_iH) pDoc->LimiterTailleFenetre(pDoc->m_iL,pDoc->m_iH);
	CScrollView::CalcWindowRect(lpClientRect, nAdjustType);
}
//________________________________________
void CBkView::OnMouseMove(UINT nFlags, CPoint point) 
{
	short x,y;
	long w;
	//CRect r;

	CBkDoc* pDoc=GetDocument();
	x=point.x+pDoc->m_iXpos;
	y=point.y+pDoc->m_iYpos;

	GestionCurseurSouris(x,y);
	//Coordonnes absolues
	pDoc->m_iX=(short)x;
	pDoc->m_iY=(short)y;
	w=pDoc->getpixelcolor(pDoc->image,x,y);
	if (w!=-1) pDoc->m_iW=w;
	CScrollView::OnMouseMove(nFlags, point);
}
//________________________________________
void CBkView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CBkDoc* pDoc=GetDocument();
	//MAJ_Fen();
	Invalidate();
	//pDoc->UpdateAllViews(NULL);
	CScrollView::OnLButtonUp(nFlags, point);
}
//________________________________________
void CBkView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	short x,y;
	long w;
	CRectTracker tracker;
	CBkDoc* pDoc=GetDocument();
	x=point.x+pDoc->m_iXpos;
	y=point.y+pDoc->m_iYpos;

	GestionCurseurSouris(point.x,point.y);

	if (pDoc->m_tracker.HitTest(point)<0)
	{
		if (pDoc->m_tracker.TrackRubberBand(this,point,TRUE))
		{
			//MessageBeep(0);//Beep
			/*
			if (pDoc->m_tracker.m_nStyle & CRectTracker::resizeInside)
			{
				pDoc->m_tracker.m_nStyle &= ~CRectTracker::resizeInside;
				pDoc->m_tracker.m_nStyle |= CRectTracker::resizeOutside;
			}
			else
			{
				pDoc->m_tracker.m_nStyle &= ~CRectTracker::resizeOutside;
				pDoc->m_tracker.m_nStyle |= CRectTracker::resizeInside;
			}
			*/
			//Toujours Inside pour fonction GestionCurseurSouris
			pDoc->m_tracker.m_nStyle |= CRectTracker::resizeInside;

			//Trac d'un segment profil
			pDoc->m_p.iX1=pDoc->m_tracker.m_rect.left+pDoc->m_iXpos;
			pDoc->m_p.iY1=pDoc->m_tracker.m_rect.top+pDoc->m_iYpos;
			pDoc->m_p.iX2=pDoc->m_tracker.m_rect.right+pDoc->m_iXpos;
			pDoc->m_p.iY2=pDoc->m_tracker.m_rect.bottom+pDoc->m_iYpos;
			pDoc->m_iType=pDoc->m_iType|4;
			pDoc->m_tracker.m_nHandleSize=8;
		}
	}
	else
	if (pDoc->m_tracker.Track(this,point,FALSE))
	{
		//Quand on dplace la zone digitalise...
		//Trac d'un segment profilz
		pDoc->m_p.iX1=pDoc->m_tracker.m_rect.left+pDoc->m_iXpos;
		pDoc->m_p.iY1=pDoc->m_tracker.m_rect.top+pDoc->m_iYpos;
		pDoc->m_p.iX2=pDoc->m_tracker.m_rect.right+pDoc->m_iXpos;
		pDoc->m_p.iY2=pDoc->m_tracker.m_rect.bottom+pDoc->m_iYpos;
		pDoc->m_iType=pDoc->m_iType|4;
	}
	//Si tracker trop petit, on le supprime...
	if (abs(pDoc->m_tracker.m_rect.left-pDoc->m_tracker.m_rect.right)<15 && abs(pDoc->m_tracker.m_rect.bottom-pDoc->m_tracker.m_rect.top)<15)
	{
		pDoc->InitTracker();
		pDoc->m_tracker.m_nHandleSize=0;
		//MessageBeep(0);//Beep
		//Marque de pointage
		pDoc->m_iDx=x;
		pDoc->m_iDy=y;
		w=pDoc->getpixelcolor(pDoc->image,x,y);
		if (w!=-1) pDoc->m_iDw=w;
	}
	//MAJ_Fen();
	Invalidate();
	CScrollView::OnLButtonDown(nFlags, point);
}
//________________________________________
void CBkView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	class CBkDoc* pDoc=GetDocument();
	CMenu menu;
	BOOL ok=menu.LoadMenu(IDR_MENU1);
	CMenu* pPopup=menu.GetSubMenu(0);
	if (m_pApp->pDocGrab==pDoc)
	{
		menu.EnableMenuItem(ID__CUR_SOURIS,MF_GRAYED);
		menu.EnableMenuItem(ID__EFF__PROFILS,MF_GRAYED);
	}
	if (m_pApp->pDocGrab!=NULL)
	{
		menu.EnableMenuItem(ID__GRAB,MF_GRAYED);
		menu.EnableMenuItem(ID__CUR_SOURIS,MF_GRAYED);
	}
	if (m_pApp->m_iCarte==0)
	{
		menu.EnableMenuItem(ID__STOPGRAB,MF_GRAYED);
		menu.EnableMenuItem(ID__GRAB,MF_GRAYED);
	}
	if (m_pApp->pDocGrab==NULL)
	{
		menu.EnableMenuItem(ID__STOPGRAB,MF_GRAYED);
	}
	if ((pDoc->m_iType&4)!=4)
	{
		menu.EnableMenuItem(ID__EFF__PROFILS,MF_GRAYED);
	}
	if (pPopup!=NULL) pPopup->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,point.x,point.y,this,NULL);
}
//________________________________________
void CBkView::MarqueDePointage(CDC *pDC,short x,short y,short NoPlume,BOOL OK)
{
	CPen *pOldPen;
	short i,X,Y;
	class CBkDoc *pDoc=GetDocument();
	X=x-pDoc->m_iXpos;
	Y=y-pDoc->m_iYpos;
	pOldPen=pDC->SelectObject(&m_pApp->plume[0]);//0: plume de contour
	pDC->MoveTo(X-3,Y-3);
	pDC->LineTo(X+3,Y-3);
	pDC->LineTo(X+3,Y+3);
	pDC->LineTo(X-3,Y+3);
	pDC->LineTo(X-3,Y-3);
	pDC->SelectObject(&m_pApp->plume[NoPlume]);
	for (i=X-2;i<=X+2;i++)
	{
		pDC->MoveTo(i,Y-2);
		pDC->LineTo(i,Y+3);
	}
	//Affichage luminance ou altitude
	if (OK && pDoc->m_iDw>=0)
	{
		CFont *pOldF;
		//Fonte incline...
		pOldF=pDC->SelectObject(&m_pApp->fonteC[0+90]);
		pDC->SetTextAlign(TA_CENTER|TA_BOTTOM);							
		COLORREF clrOld=pDC->SetTextColor(m_pApp->couleur[1]);
		int nOldMode=pDC->SetBkMode(TRANSPARENT);
		CString s;
		float zmm;
		long 
			w,wR,wV,wB,
			NbB,channels;
		count_channels(pDoc->image,&channels);NbB=channels*8;
		if (NbB==8)
		{
			//Luminance
			w=pDoc->m_iDw;
			s.Format("W:%d",w);
		}
		else
		if (NbB==24)
		{
			//Luminance
			w=pDoc->m_iDw;
			wR=w&255;
			wV=(w/256)&255;
			wB=(w/65536)&255;
			s.Format("R:%d,V:%d,B:%d",wR,wV,wB);
		}
		pDC->TextOut(X,Y-4,s);
		pDC->SetTextColor(clrOld);
		pDC->SelectObject(pOldF);
		pDC->SetBkMode(nOldMode);
	}
	pDC->SelectObject(pOldPen);
}
//________________________________________
void CBkView::SegmentProfil(CDC *pDC)
{
	class CBkDoc *pDoc=GetDocument();
	CPen *pOld;
	pOld=pDC->SelectObject(&m_pApp->plume[2]);
	MarqueDePointage(pDC,pDoc->m_p.iX1,pDoc->m_p.iY1,2,FALSE);
	MarqueDePointage(pDC,pDoc->m_p.iX2,pDoc->m_p.iY2,2,FALSE);
	pDC->MoveTo(pDoc->m_p.iX1-pDoc->m_iXpos,pDoc->m_p.iY1-pDoc->m_iYpos);
	pDC->LineTo(pDoc->m_p.iX2-pDoc->m_iXpos,pDoc->m_p.iY2-pDoc->m_iYpos);
	pDC->SelectObject(pOld);
}
//________________________________________
void CBkView::ProfilH(CDC *pDC)
{
	short 
		X1,Y1,X2,Y2,
		i;
	CBkDoc* pDoc=GetDocument();
	CPen
		*pOldPen;

	pOldPen=pDC->SelectObject(&m_pApp->plume[3]);

	//Trac profil H...
	if (pDoc->m_p.iX1!=-1 && pDoc->m_p.iY1!=-1 && pDoc->m_p.iX2!=-1 && pDoc->m_p.iY2!=-1)
	{
		SegmentProfil(pDC);
		X1=pDoc->m_p.iX1-pDoc->m_iXpos;
		Y1=pDoc->m_p.iY1-pDoc->m_iYpos;
		X2=pDoc->m_p.iX2-pDoc->m_iXpos;
		Y2=pDoc->m_p.iY2-pDoc->m_iYpos;

		pDC->MoveTo(X1,pDoc->m_iH-0-pDoc->m_iYpos);
		pDC->LineTo(X1,pDoc->m_iH-255-pDoc->m_iYpos);
		pDC->LineTo(X2,pDoc->m_iH-255-pDoc->m_iYpos);
		pDC->LineTo(X2,pDoc->m_iH-0-pDoc->m_iYpos);
		pDC->LineTo(X1,pDoc->m_iH-0-pDoc->m_iYpos);
		
		if (pDoc->m_fT[0][0]!=1e10 && pDoc->m_fT[0][1]!=1e10)
			pDC->MoveTo((short)(pDoc->m_fT[0][0]-pDoc->m_iXpos),(short)(pDoc->m_iH-pDoc->m_fT[0][1]-pDoc->m_iYpos));
		for (i=1;i<pDoc->m_iNbMax;i++)
		{
			if (pDoc->m_fT[i][0]!=1e10 && pDoc->m_fT[i][1]!=1e10)
				pDC->LineTo((short)(pDoc->m_fT[i][0]-pDoc->m_iXpos),(short)(pDoc->m_iH-pDoc->m_fT[i][1]-pDoc->m_iYpos));
		}
	} 
	pDC->SelectObject(pOldPen);
}
//________________________________________
void CBkView::ProfilV(CDC *pDC)
{
	short 
		X1,Y1,X2,Y2,
		i;
	CBkDoc* pDoc=GetDocument();
	CPen *pOldPen;

	pOldPen=pDC->SelectObject(&m_pApp->plume[4]);

	//Trac profil V...
	if (pDoc->m_p.iX1!=-1 && pDoc->m_p.iY1!=-1 && pDoc->m_p.iX2!=-1 && pDoc->m_p.iY2!=-1)
	{
		SegmentProfil(pDC);
		X1=pDoc->m_p.iX1-pDoc->m_iXpos;
		Y1=pDoc->m_p.iY1-pDoc->m_iYpos;
		X2=pDoc->m_p.iX2-pDoc->m_iXpos;
		Y2=pDoc->m_p.iY2-pDoc->m_iYpos;

		pDC->MoveTo(0-pDoc->m_iXpos,Y1);
		pDC->LineTo(255-pDoc->m_iXpos,Y1);
		pDC->LineTo(255-pDoc->m_iXpos,Y2);
		pDC->LineTo(0-pDoc->m_iXpos,Y2);
		pDC->LineTo(0-pDoc->m_iXpos,Y1);
		
		if (pDoc->m_fT[0][3]!=1e10 && pDoc->m_fT[0][4]!=1e10)
			pDC->MoveTo((short)(pDoc->m_fT[0][3]-pDoc->m_iXpos),(short)(pDoc->m_fT[0][4]-pDoc->m_iYpos));
		for (i=1;i<pDoc->m_iNbMax;i++)
		{
			if (pDoc->m_fT[i][3]!=1e10 && pDoc->m_fT[i][4]!=1e10)
				pDC->LineTo((short)(pDoc->m_fT[i][3]-pDoc->m_iXpos),(short)(pDoc->m_fT[i][4]-pDoc->m_iYpos));
		}
	} 
	pDC->SelectObject(pOldPen);
}
//________________________________________
void CBkView::GaussH(CDC *pDC)
{
	short 
		i,X,Y;
	long w;
	float 
		x,y;
	CBkDoc* pDoc=GetDocument();
	CPen *pOldPen;

	pOldPen=pDC->SelectObject(&m_pApp->plume[3]);
	//Trac gaussienne horizontale thorique
	if (pDoc->m_fT[0][0]!=1e10 && pDoc->m_fT[0][2]!=1e10)
		pDC->MoveTo((short)(pDoc->m_fT[0][0]-pDoc->m_iXpos),(short)(pDoc->m_iH-pDoc->m_fT[0][2]-pDoc->m_iYpos));
	for (i=1;i<pDoc->m_iNbMax;i++)
	{
		if (pDoc->m_fT[i][0]!=1e10 && pDoc->m_fT[i][2]!=1e10)
			pDC->LineTo((short)(pDoc->m_fT[i][0]-pDoc->m_iXpos),(short)(pDoc->m_iH-pDoc->m_fT[i][2]-pDoc->m_iYpos));
	}
	//Matrialisation IMax/e                 
	//Maxi
	w=0;
	for (i=0;i<pDoc->m_iNbMax;i++)
	{
		if (pDoc->m_fT[i][2]!=1e10)
		{
			if (pDoc->m_fT[i][2]>w) w=(int)pDoc->m_fT[i][2];
		}
	}
	i=0;
	do
	{
		if (pDoc->m_fT[i][2]!=1e10)
		{ 
			y=pDoc->m_fT[i][2];x=pDoc->m_fT[i][0];
		}
		else
		{
			x=0;y=0;
		}
		i++;
	}
	while (i<pDoc->m_iNbMax && y<1.0*w/7.39);
	y=-y+pDoc->m_iH;
	if (x>0 && x<pDoc->m_iL && y>=0 && y<pDoc->m_iH)
	{
		MarqueDePointage(pDC,x,y,3,FALSE);//Plume n3
	}
	i=pDoc->m_iNbMax;
	do
	{
		if (pDoc->m_fT[i][2]!=1e10)
		{ 
			y=pDoc->m_fT[i][2];x=pDoc->m_fT[i][0];
		}
		else
		{
			x=0;y=0;
		}
		i--;
	}
	while (i>0 && y<1.0*w/7.39);
	y=-y+pDoc->m_iH;
	if (x>0 && x<pDoc->m_iL && y>=0 && y<pDoc->m_iH)		
	{
		MarqueDePointage(pDC,x,y,3,FALSE);//Plume n3
	}
	pDC->SelectObject(pOldPen);
}
//________________________________________
void CBkView::GaussV(CDC *pDC)
{
	CBkDoc* pDoc=GetDocument();
	short 
		i,X,Y;
	long w;
		float 
			x,y;
	CPen *pOldPen;

	pOldPen=pDC->SelectObject(&m_pApp->plume[4]);
	//Trac gaussienne verticale
	if (pDoc->m_fT[0][4]!=1e10 && pDoc->m_fT[0][5]!=1e10)
		pDC->MoveTo((short)(pDoc->m_fT[0][5]-pDoc->m_iXpos),(short)(pDoc->m_fT[0][4]-pDoc->m_iYpos));
	for (i=1;i<pDoc->m_iNbMax;i++)
	{
		if (pDoc->m_fT[i][4]!=1e10 && pDoc->m_fT[i][5]!=1e10)
			pDC->LineTo((short)(pDoc->m_fT[i][5]-pDoc->m_iXpos),(short)(pDoc->m_fT[i][4]-pDoc->m_iYpos));
	}
	//Matrialisation IMax/e                 
	//Maxi
	w=0;
	for (i=0;i<pDoc->m_iNbMax;i++)
	{
		if (pDoc->m_fT[i][5]!=1e10)
		{
			if (pDoc->m_fT[i][5]>w) w=(int)pDoc->m_fT[i][5];
		}
	}
	i=0;
	do
	{
		if (pDoc->m_fT[i][5]!=1e10)
		{ 
			x=pDoc->m_fT[i][5];y=pDoc->m_fT[i][4];
		}
		else
		{
			x=0;y=0;
		}
		i++;
	}
	while (i<pDoc->m_iNbMax && x<1.0*w/7.39);
	if (x>0 && x<pDoc->m_iL && y>=0 && y<pDoc->m_iH)
	{
		MarqueDePointage(pDC,x,y,4,FALSE);//Plume n4
	}
	i=pDoc->m_iNbMax;
	do
	{
		if (pDoc->m_fT[i][5]!=1e10)
		{ 
			x=pDoc->m_fT[i][5];y=pDoc->m_fT[i][4];
		}
		else
		{
			x=0;y=0;
		}
		i--;
	}
	while (i>0 && x<1.0*w/7.39);
	if (x>0 && x<pDoc->m_iL && y>=0 && y<pDoc->m_iH)
	{
		MarqueDePointage(pDC,x,y,4,FALSE);//Plume n4
	}
	pDC->SelectObject(pOldPen);
}
//________________________________________
void CBkView::MAJ_Fen()
{
	CBkDoc* pDoc=GetDocument();
	CRect r;
	GetParent()->GetWindowRect(r);
	ScreenToClient(r);
	InvalidateRect(r,TRUE);
	pDoc->UpdateAllViews(this,(LPARAM)(LPCRECT)r);
}
//________________________________________
void CBkView::TraceTracker(CDC *pDC,char Type)
{
	class CBkDoc* pDoc=GetDocument();
	CPen *pOld;
	pOld=pDC->SelectObject(&m_pApp->plume[7]);
	if (Type==0)
	{
		//Rectangle
		pDoc->m_tracker.Draw(pDC);
	}
	else
	if (Type==1)
	{
		//Ellipse
		pDoc->m_tracker.Draw(pDC);
		pDC->Arc(pDoc->m_tracker.m_rect.left,pDoc->m_tracker.m_rect.bottom,pDoc->m_tracker.m_rect.right,pDoc->m_tracker.m_rect.top,pDoc->m_tracker.m_rect.left,pDoc->m_tracker.m_rect.bottom,pDoc->m_tracker.m_rect.left,pDoc->m_tracker.m_rect.bottom);
	}
	pDC->SelectObject(pOld);        
}
//________________________________________
void CBkView::GrabContinu(class CBkDoc *pDoc)
{
	m_pApp->pDocGrab=pDoc;
	//Attendre 300 ms pour gestion des boutons du menu...
	m_OK=FALSE;SetTimer(98,300,NULL);
} 
//________________________________________
void CBkView::GrabArret()
{
	KillTimer(98);
	KillTimer(99);
	grab_image(&(m_pApp->pDocGrab->image),m_pApp->pDocGrab->m_lFGHandle);


	m_pApp->pDocGrab=NULL;
	close_all_framegrabbers();
} 
//________________________________________
void CBkView::OnTimer(UINT nIDEvent) 
{
	short i;
	Herror err;
	CBkDoc* pDoc=GetDocument();
	//CString z;
	if (m_pApp->pDocGrab!=NULL && m_pApp->m_iCarte>=2 && m_OK==FALSE)
	{
		set_check("~give_error");
		m_OK=TRUE;
		switch (nIDEvent)	
		{
			case 98:
				KillTimer(98);
				//1 image toutes les 50 ms = 20 images par seconde
				SetTimer(99,10,NULL);
			break;
			case 99:
				for (i=0;i</*3*/1;i++)
				{
					err=grab_image/*_async*/(&(m_pApp->pDocGrab->image),m_pApp->pDocGrab->m_lFGHandle/*,-1.0*/);
					if (err!=2)
					{
						//get_error_text((long)err,message);AfxMessageBox(message);
						KillTimer(99);
						m_pApp->pDocGrab=NULL;
						close_all_framegrabbers();
						AfxMessageBox("Erreur sur fonction Acq. permanente !\nVrifier votre camra (shutter, diaphragme, ...");
					}
					//zoom_image_size(m_pApp->pDocGrab->image,&(m_pApp->pDocGrab->image),m_pApp->pDocGrab->m_iL,m_pApp->pDocGrab->m_iH,"constant");
					disp_obj(m_pApp->pDocGrab->image,m_lWindowID);
				}
			break;
		}
		set_check("give_error");
		m_OK=FALSE;
	}
	CScrollView::OnTimer(nIDEvent);
}
//________________________________________
/*
//Le changement de curseur au dessus du tracker ne fonctionne pas...
BOOL CBkView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	CBkDoc* pDoc=GetDocument();
	if (pWnd==this && pDoc->m_tracker.SetCursor(this,nHitTest))
	{
		//MessageBeep(0);//Beep
		return TRUE;
	}
	return CScrollView::OnSetCursor(pWnd, nHitTest, message);
}
*/
//________________________________________
void CBkView::GestionCurseurSouris(short x,short y)
{
	//Pour palier au dysfonctionnement de OnSetCursor...
	CBkDoc* pDoc=GetDocument();
	short xa,ya,xd,yd,xm,ym,ec;
	//Tracker
	xd=pDoc->m_tracker.m_rect.left;	
	xa=pDoc->m_tracker.m_rect.right;
	yd=pDoc->m_tracker.m_rect.top;
	ya=pDoc->m_tracker.m_rect.bottom;
	xm=(xa+xd)/2;
	ym=(ya+yd)/2;
	//Position souris : x,y
	
	//IDC_ARROW   Standard arrow cursor
	//IDC_IBEAM   Standard text-insertion cursor
	//IDC_WAIT   Hourglass cursor used when Windows performs a time-consuming task
	//IDC_CROSS   Cross-hair cursor for selection
	//IDC_UPARROW   Arrow that points straight up
	//IDC_SIZE   Cursor to use to resize a window
	//IDC_ICON   Cursor to use to drag a file
	//IDC_SIZENWSE   Two-headed arrow with ends at upper left and lower right
	//IDC_SIZENESW   Two-headed arrow with ends at upper right and lower left
	//IDC_SIZEWE   Horizontal two-headed arrow
	//IDC_SIZENS   Vertical two-headed arrow
	
  HCURSOR hCursor;
	ec=pDoc->m_tracker.m_nHandleSize;
	if ((x-xd)<ec && x>xd && (y-yd)<ec && y>yd)
	{
	  hCursor=m_pApp->LoadStandardCursor(IDC_SIZENWSE);
	}
	else
	if (xa>x && (xa-x)<ec && ya>y && (ya-y)<ec)
	{
	  hCursor=m_pApp->LoadStandardCursor(IDC_SIZENWSE);
	}
	else
	if ((x-xd)<ec && x>xd && ya>y && (ya-y)<ec)
	{
	  hCursor=m_pApp->LoadStandardCursor(IDC_SIZENESW);
	}
	else
	if (xa>x && (xa-x)<ec && (y-yd)<ec && y>yd)
	{
	  hCursor=m_pApp->LoadStandardCursor(IDC_SIZENESW);
	}
	else
	if (abs(x-xm)<ec/2 && (y-yd)<ec && y>yd)
	{
	  hCursor=m_pApp->LoadStandardCursor(IDC_SIZENS);
	}
	else
	if (abs(x-xm)<ec/2 && ya>y && (ya-y)<ec)
	{
	  hCursor=m_pApp->LoadStandardCursor(IDC_SIZENS);
	}
	else
	if ((x-xd)<ec && x>xd && abs(y-ym)<ec/2)
	{
	  hCursor=m_pApp->LoadStandardCursor(IDC_SIZEWE);
	}
	else
	if (xa>x && (xa-x)<ec && abs(y-ym)<ec/2)
	{
	  hCursor=m_pApp->LoadStandardCursor(IDC_SIZEWE);
	}
	else
	if (x<xa && x>xd && y<ya && y>yd)
	{
	  hCursor=m_pApp->LoadStandardCursor(IDC_ARROW);
	}
	else
		hCursor = m_pApp->LoadStandardCursor(IDC_ARROW);
	SetCursor(hCursor);
}
