// CalbDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "CalbDlg.h"
#include "BkDoc.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CCalbDlg dialog
CCalbDlg::CCalbDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCalbDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCalbDlg)
	m_OKXY = FALSE;
	m_s = _T("");
	m_fPixX = 0.0f;
	m_fMmX = 0.0f;
	//}}AFX_DATA_INIT
}
//________________________________________
void CCalbDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCalbDlg)
	DDX_Check(pDX, IDC_COORD_XY, m_OKXY);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Text(pDX, IDC_PIXX, m_fPixX);
	DDX_Text(pDX, IDC_MMX, m_fMmX);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CCalbDlg, CDialog)
	//{{AFX_MSG_MAP(CCalbDlg)
	ON_BN_CLICKED(IDC_COORD_XY, OnCoordXy)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CCalbDlg message handlers
BOOL CCalbDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	m_OKXY=m_pDoc->m_OKXY;
	
	if (1.0/m_pDoc->m_fEchXY>1)
	{
		m_fPixX=1;
		m_fMmX=1/m_pDoc->m_fEchXY;
	}
	else
	{
		m_fPixX=1*m_pDoc->m_fEchXY;
		m_fMmX=1;
	}

	long channel;
	count_channels(m_pDoc->image,&channel);
	if (channel==1)
		m_s.Format("Image courante:\n%s",m_pDoc->m_sNomFic);
	else
		m_s="Image couleur, talonnage:\nw=(30*r+59*g+11*b)/100";
	if (!m_OKXY)
	{
		GetDlgItem(IDC_PIXX)->EnableWindow(FALSE);
		GetDlgItem(IDC_MMX)->EnableWindow(FALSE);
	}

	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CCalbDlg::OnOK() 
{
	float x,z;
	UpdateData(TRUE);
	if (m_OKXY)
	{
		//En mm suivant XY
		m_fPixX=fabs(m_fPixX);
		if (m_fPixX==0) m_fPixX=1;
		m_fMmX=fabs(m_fMmX);
		if (m_fMmX==0) m_fMmX=1;

		x=m_fPixX/m_fMmX;
		m_pDoc->m_fEchXY=x;
		//Facteur suivant xy
		x=m_pDoc->m_iL/x;
		m_pDoc->m_fFactXY=1e-10;
		do
		{
			m_pDoc->m_fFactXY=m_pDoc->m_fFactXY*10;
		}
		while (fabs(x*m_pDoc->m_fFactXY)<1);	
		if (x*m_pDoc->m_fFactXY<2) m_pDoc->m_fFactXY=m_pDoc->m_fFactXY*10;
	}
	else
	{
		//En pixel
	}
	m_pDoc->m_OKXY=m_OKXY;
	CDialog::OnOK();
}
//________________________________________
void CCalbDlg::OnCoordXy() 
{
	UpdateData(TRUE);
	if (!m_OKXY)
	{
		GetDlgItem(IDC_PIXX)->EnableWindow(FALSE);
		GetDlgItem(IDC_MMX)->EnableWindow(FALSE);
		m_s="Units x&y: pixel";
	}
	else
	{
		GetDlgItem(IDC_PIXX)->EnableWindow(TRUE);
		GetDlgItem(IDC_MMX)->EnableWindow(TRUE);
		m_s="Units x&y: mm";
	}
	UpdateData(FALSE);
}
