// Code.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "Code.h"
#include "Bkdoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CCode
CCode::CCode(CBkDoc *pDoc)
{
	m_pDoc=pDoc;
	Affectation();
	//Couleurs
	m_lCb=RGB(0,0,0);
	m_lCf=RGB(255,255,255);
	m_iTrait=3;                       
	m_iBlanc=3;
	m_iHaut=100;
	m_iHaut=m_iHaut/2;							//Demi-hauteur du code
	m_iLarg=2*m_iTrait+5*m_iBlanc;	//Largeur d'un chiffre du code en mm, bas sur le chiffre 8C

	m_iL=pDoc->m_iL;
	m_iH=pDoc->m_iH;
	m_R=new unsigned char[m_iL*m_iH];
	m_G=new unsigned char[m_iL*m_iH];
	m_B=new unsigned char[m_iL*m_iH];
	get_pixelcolor(pDoc->image,m_iL,m_iH,m_R,m_G,m_B);
}
//________________________________________
CCode::~CCode()
{
	delete m_R;delete m_G;delete m_B;

}
//________________________________________
BEGIN_MESSAGE_MAP(CCode, CWnd)
	//{{AFX_MSG_MAP(CCode)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CCode message handlers
void CCode::Affectation(void)
{
	//Affectation des codes dans le tableau C
	C[0][0]=13;	C[0][1]=39;	C[0][2]=114;	//Chiffre 0
	C[1][0]=25;	C[1][1]=51;	C[1][2]=102;	//Chiffre 1
	C[2][0]=19;	C[2][1]=27;	C[2][2]=108;	//Chiffre 2
	C[3][0]=61;	C[3][1]=33;	C[3][2]=66;		//Chiffre 3
	C[4][0]=35;	C[4][1]=29;	C[4][2]=92;		//Chiffre 4
	C[5][0]=49;	C[5][1]=57;	C[5][2]=78;		//Chiffre 5
	C[6][0]=47;	C[6][1]=5;	C[6][2]=80;		//Chiffre 6
	C[7][0]=59;	C[7][1]=17;	C[7][2]=68;		//Chiffre 7
	C[8][0]=55;	C[8][1]=9;	C[8][2]=72;		//Chiffre 8
	C[9][0]=11;	C[9][1]=23;	C[9][2]=116;	//Chiffre 9
	//Types pour codes de 1  6 en fonction du dernier chiffre
	m_sType[0]="AAAAAA";
	m_sType[1]="AABABB";
	m_sType[2]="AABBAB";
	m_sType[3]="AABBBA";
	m_sType[4]="ABAABB";
	m_sType[5]="ABBAAB";
	m_sType[6]="ABBBAA";
	m_sType[7]="ABABAB";
	m_sType[8]="ABABBA";
	m_sType[9]="ABBABA";
}
//________________________________________
void CCode::TraceCode(short x,short y,CString Code)
{
	CString s;
	int i,k,d;
	short X;
	char c;
	if (Code.GetLength()!=13)
	{
		//Erreur !
	}
	else
	{
		Rectangle(x-5,y-1*m_iHaut-5,x+13.5*m_iLarg+5,y+1.5*m_iHaut+5,m_lCf);

		CodeRef('G',x,y);//Barre rfrence gauche
		CodeRef('M',x,y);//Barre rfrence milieu
		CodeRef('D',x,y);//Barre rfrence droite

		//Premier chiffre pour type code
		s.Format("%c",Code[0]);
		sscanf(s,"%d",&d);
		//Extraction des autres codes
		X=x+2*m_iTrait+m_iBlanc+m_iLarg/2;
		for (k=0;k<6;k++)
		{
			s.Format("%c",Code[k+1]);
			sscanf(s,"%d",&i);
			c=m_sType[d][k];
			//s.Format("%c",c);
			//m_pDes->texte(X,y-1.5*m_fHaut,s);

			CodeChiffre(i,k+1,c,x,y);
			X=X+m_iLarg;
		}
		X=X+2*m_iTrait+3*m_iBlanc;
		for (k=6;k<12;k++)
		{
			s.Format("%c",Code[k+1]);
			sscanf(s,"%d",&i);
			//s.Format("%d",i);
			//m_pDes->texte(X,y-1.2*m_fHaut,s);
			//s.Format("C");
			//m_pDes->texte(X,y-1.5*m_fHaut,s);
			CodeChiffre(i,k+1,'C',x,y);
			X=X+m_iLarg;
		}
	}
	gen_image3(&(m_pDoc->image),"byte",m_iL,m_iH,(long)m_R,(long)m_G,(long)m_B);
}
//________________________________________
void CCode::Couleur(long B,long E)
{
	m_lCb=B;
	m_lCf=E;
}
//________________________________________
void CCode::CodeRef(char Pos,short x,short y)
{
	short X,X1;

	switch (Pos)
	{
		case 'G'://Gauche
			X=x;
			Rectangle(X,y-1*m_iHaut,X+1*m_iTrait,y+1.4*m_iHaut,m_lCb);
			X=X+m_iTrait;
			X=X+m_iBlanc;
			Rectangle(X,y-1*m_iHaut,X+1*m_iTrait,y+1.4*m_iHaut,m_lCb);
			X=X+m_iTrait;
		break;
		case 'M'://Milieu
			X=x+2*m_iTrait+1*m_iBlanc+6*m_iLarg;
			X1=X+2*m_iTrait+3*m_iBlanc;
			X1=X+m_iBlanc;
			X=X1;
			X1=X+m_iTrait;
			Rectangle(X,y-1*m_iHaut,X1,y+1.4*m_iHaut,m_lCb);
			X=X1;
			X1=X+m_iBlanc;
			X=X1;
			X1=X+m_iTrait;
			Rectangle(X,y-1*m_iHaut,X1,y+1.4*m_iHaut,m_lCb);
			X=X1;
			X1=X+m_iBlanc;
		break;
		case 'D'://Droite
			X=x+4*m_iTrait+4*m_iBlanc+12*m_iLarg;
			X1=X+2*m_iTrait+1*m_iBlanc;
			X1=X+m_iTrait;
			Rectangle(X,y-1*m_iHaut,X1,y+1.4*m_iHaut,m_lCb);
			X=X1;
			X1=X+m_iBlanc;
			X=X1;
			X1=X+m_iTrait;
			Rectangle(X,y-1*m_iHaut,X1,y+1.4*m_iHaut,m_lCb);
		break;
	}
}
//________________________________________
//Trac du code du Chiffre [0,9] _________
void CCode::CodeChiffre(short Chiffre,short No,char Digit,short x,short y)
{
	short i,j,k;
	short X;

	if (Digit=='A')	k=0; 
		else 
	if (Digit=='B')	k=1;
		else k=2;//'C' 

	if (Digit=='C')
	{
		//On dcale  cause du code de dbut et de milieu
		X=x+(No-1)*m_iLarg+4*m_iTrait+4*m_iBlanc;
		i=64;
		while (i>=1)
		{
			if (C[Chiffre][k]&i)
			{
				Rectangle(X,y-m_iHaut,X+m_iTrait,y+m_iHaut,m_lCb);
				X=X+m_iTrait;
			}
			else
			{
				X=X+m_iBlanc;
			}
			i=i/2;
		}
	}
	else
	{
		//On dcale  cause du code de dbut
		X=x+No*m_iLarg+2*m_iTrait+1*m_iBlanc;
		//On crit le code de droite vers la gauche
		i=1;
		while (i<=64)
		{
			if (C[Chiffre][k]&i)
			{
				Rectangle(X-m_iTrait,y-m_iHaut,X,y+m_iHaut,m_lCb);
				X=X-m_iTrait;
			}
			else
			{
				X=X-m_iBlanc;
			}
			i=i*2;

		}
	}
}
//________________________________________
void CCode::Rectangle(short xd,short yd,short xa,short ya,long coul)
{
	short i,j;
	for (i=xd;i<xa;i++)
	{
		for (j=yd;j<=ya;j++)
		{
			if (i>=0 && i<m_iL && j>0 && j<m_iH)
			{
				//Le code doit tre dans l'image...
				m_R[i+j*m_iL]=coul&255;
				m_G[i+j*m_iL]=(coul/256)&255;
				m_B[i+j*m_iL]=(coul/65536)&255;
			}
		}
	}
}
//________________________________________
void CCode::get_pixelcolor(Hobject image,short l,short h,unsigned char *w_R,unsigned char *w_V,unsigned char *w_B) 
{
	long p;
	long L,H,channels;
	char lpcsType[128];
	unsigned char *R,*V,*B;

	count_channels(image,&channels);
	if (channels==1) 
	{
		get_image_pointer1(image,(long*)&R,lpcsType,&L,&H);
		if (L!=l || H!=h) AfxMessageBox("Erreur sur taille image !");

		for (p=0;p<l*h;p++)
		{
			w_R[p]=*(R+p);
			w_V[p]=*(R+p);
			w_B[p]=*(R+p);
		}
	}
	else
	{
		get_image_pointer3(image,(long*)&R,(long*)&V,(long*)&B,lpcsType,&L,&H);
		if (L!=l || H!=h) AfxMessageBox("Erreur sur taille image !");
		for (p=0;p<l*h;p++)
		{
			w_R[p]=*(R+p);
			w_V[p]=*(V+p);
			w_B[p]=*(B+p);
		}
	}
}
