// CodeHalcon.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "CodeHalcon.h"
#include "Bkdoc.h"
#include "Webcam.h"
#include "MatroxOrion.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CCodeHalcon dialog
CCodeHalcon::CCodeHalcon(CWnd* pParent /*=NULL*/)
	: CDialog(CCodeHalcon::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCodeHalcon)
	m_s1 = _T("");
	m_s2 = _T("");
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_CODE_HALCON,pParent);
}
void CCodeHalcon::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCodeHalcon)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDEXTRAIRE, m_btnExtraire);
	DDX_Text(pDX, IDC_STATIC1, m_s1);
	DDX_Text(pDX, IDC_STATIC2, m_s2);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CCodeHalcon, CDialog)
	//{{AFX_MSG_MAP(CCodeHalcon)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDEXTRAIRE, OnExtraire)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CCodeHalcon message handlers
BOOL CCodeHalcon::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_pApp=(CBkApp*)AfxGetApp();
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	m_R=new unsigned char[m_pApp->m_iL*m_pApp->m_iH];
	m_G=new unsigned char[m_pApp->m_iL*m_pApp->m_iH];
	m_B=new unsigned char[m_pApp->m_iL*m_pApp->m_iH];

	m_s1="Cliquer sur Extraire...";
	//m_s1="Code extrait: ?";
	m_iN=0;
	UpdateData(FALSE);
	m_OK=FALSE;
	return TRUE;
}
//________________________________________
void CCodeHalcon::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CCodeHalcon::OnCancel() 
{
	if (m_OK==TRUE) KillTimer(25);
	if (m_iNb==0)
	{
		m_pDoc->m_sNomFic=m_pDoc->m_sCode+".tif";m_pDoc->EcritTitre();
	}
	delete m_R;delete m_B;delete m_G;
	m_pApp->m_pCodeDlg=NULL;
	CDialog::OnCancel();
}
//________________________________________
void CCodeHalcon::PostNcDestroy() 
{
	//delete m_R;delete m_B;delete m_B;
	if (m_pApp->m_pCodeDlg!=NULL)
	{
		m_pApp->m_pCodeDlg=NULL;
		delete m_R;delete m_B;delete m_G;
	}
	delete this;
	CDialog::PostNcDestroy();
}
//________________________________________
CString CCodeHalcon::ExtraireEAN13(Hobject image) 
{
	int i;
	CString s1,s="";
	char c;

  HTuple BarCodeDescr, BarcodeFound;
  HTuple BarCode, Orientation, Characters, Reference, IsCorrect;
  Hobject CodeRegion;

	set_check("~give_error");
  set_system("do_low_error","false");
  gen_1d_bar_code_descr(HTuple("EAN 13"),HTuple(13),HTuple(13),&BarCodeDescr);
  find_1d_bar_code(image,&CodeRegion,BarCodeDescr,HTuple(),HTuple(),&BarcodeFound,&BarCode,&Orientation);
	decode_1d_bar_code(BarCode,BarCodeDescr,&Characters,&Reference,&IsCorrect);
  if (IsCorrect!=0)
  {
		for (i=0; i<Characters.Num();i++)
    {
      c=*(Characters[i]);
			s1.Format("%c",c);
			s=s+s1;
    }
		if (i!=0)
		{
		}
		else
		{
			s="";
		}
  }
  else
  {
		s="";
  }
  set_system("do_low_error","true");
	set_check("give_error");
	return s;
}
//________________________________________
void CCodeHalcon::OnTimer(UINT nIDEvent) 
{
	short i,j;
	long	
		w,
		L=m_pApp->m_iL,
		H=m_pApp->m_iH;
	unsigned char 
		r,g,b;
	float k;
	CString s;
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	if (m_pDoc!=NULL)
	{
		if (m_pApp->m_iCarte==8 && m_pApp->pDocGrab==m_pDoc)
		{
			//Orion
			m_pApp->m_pOrion->GetPixelRouge(m_R);
			gen_image1(&(m_pDoc->image),"byte",L,H,(long)m_R);
		}
		else
		if (m_pApp->m_iCarte==2 && m_pApp->pDocGrab==m_pDoc)
		{
			//Webcam, transfert du buffer vers l'image
			for (i=0;i<L;i++)
			{
				for (j=0;j<H;j++)
				{
					//Webcam
					m_pDoc->m_pWeb->GetPixelColor(i,j,&r,&g,&b);
					//Conversion en nuances de gris
					//w=(30*r+59*g+11*b)/100;
					//m_R[i+j*L]=w;
					m_R[i+j*L]=r;
					//m_G[i+j*L]=w;
					m_G[i+j*L]=g;
					//m_B[i+j*L]=w;
					m_B[i+j*L]=b;
				}
			}
			//gen_image1(&(m_pDoc->image),"byte",L,H,(long)m_R);
			gen_image3(&(m_pDoc->image),"byte",L,H,(long)m_R,(long)m_G,(long)m_B);
		}
		else
		if (m_pApp->m_iCarte>2 && m_pApp->pDocGrab==m_pDoc)
		{
			//Autre numriseurs, sauf twain
			//On ramne l'image  la taille de la fentre, important si le grab n'est pas  la taille fentre...
			zoom_image_size(m_pDoc->image,&(m_pDoc->image),L,H,"constant");
		}
		s=ExtraireEAN13(m_pDoc->image);
	}
	else
		s="";	
	if (s=="")
	{
		if (m_iN==0) m_s1.Format("Code extrait : ?");
		m_iNb++;
		m_s2.Format("Code n%d lu: NON",m_iN+1);
	}
	else
	{
		m_s1.Format("Code extrait : "+s);
		//Beep en acquisition permanente
		if (m_pApp->pDocGrab==m_pDoc) Beep(1000,100);
		m_pDoc->m_sCode=s;
		m_s2.Format("Code n%d lu : OUI",m_iN+1);
		//m_s2="";
		if (m_pDoc->m_sCode!=s) m_iN++;
		m_iNb=0;
	}
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CCodeHalcon::OnExtraire() 
{
	if (m_OK==FALSE)
	{
		//Extraire
		m_btnExtraire.SetWindowText("&Arrter");
		m_iNb=0;m_iN=0;
		SetTimer(25,100,NULL);
		//m_btnCancel.EnableWindow(FALSE);
	}
	else
	{
		//Arrter
		KillTimer(25);
		m_s2="";
		UpdateData(FALSE);
		m_btnExtraire.SetWindowText("&Extraire");
		//m_btnCancel.EnableWindow(TRUE);
	}	
	m_OK=!m_OK;
}
