// CouCoDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "CouCoDlg.h"
#include "BkDoc.h"
#include "Code.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CCouCoDlg dialog
CCouCoDlg::CCouCoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCouCoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCouCoDlg)
	m_radioType = -1;
	m_s3 = _T("");
	m_radioType1 = -1;
	m_s4 = _T("");
	//}}AFX_DATA_INIT
}
void CCouCoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCouCoDlg)
	DDX_Control(pDX, IDC_SLIDER_V, m_sliderV);
	DDX_Control(pDX, IDC_SLIDER_R, m_sliderR);
	DDX_Control(pDX, IDC_SLIDER_B, m_sliderB);
	DDX_Radio(pDX, IDC_RADIOB, m_radioType);
	DDX_Text(pDX, IDC_STATIC3, m_s3);
	DDX_Radio(pDX, IDC_RADIOCOUL, m_radioType1);
	DDX_Text(pDX, IDC_STATIC4, m_s4);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CCouCoDlg, CDialog)
	//{{AFX_MSG_MAP(CCouCoDlg)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_RADIOB, OnRadiob)
	ON_BN_CLICKED(IDC_RADIOE, OnRadioe)
	ON_BN_CLICKED(IDC_RADIOMONO, OnRadiomono)
	ON_BN_CLICKED(IDC_RADIOCOUL, OnRadiocoul)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CCouCoDlg message handlers
BOOL CCouCoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	m_sliderR.SetRange(0,255);
	m_sliderV.SetRange(0,255);
	m_sliderB.SetRange(0,255);
	m_sliderR.SetPos(m_pDoc->m_lCB&255);
	m_sliderV.SetPos((m_pDoc->m_lCB/256)&255);
	m_sliderB.SetPos((m_pDoc->m_lCB/65536)&255);
	m_radioType=0;//0: barres, 1: espaces
	m_radioType1=0;//0: couleur, 1: monochrome
	m_s3.Format("RVB (%3d, %3d, %3d)",m_pDoc->m_lCB&255,(m_pDoc->m_lCB/256)&255,(m_pDoc->m_lCB/65536)&255);
	m_iNb=0;m_OK=FALSE;m_s4="";SetTimer(26,50,NULL);
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CCouCoDlg::OnCancel() 
{
	KillTimer(26);
	CDialog::OnCancel();
}
//________________________________________
void CCouCoDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CCouCoDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	UpdateData(TRUE);
	if (m_radioType1==1)
	{
		//Monochrome, on aligne sur le slider qui a boug...
		//Tout est align sur nPos
		if (nPos!=0 || nSBCode==SB_THUMBPOSITION)
		{
			m_sliderR.SetPos(nPos);
			m_sliderV.SetPos(nPos);
			m_sliderB.SetPos(nPos);
			m_s3.Format("NG (%3d)",nPos);	
		}
	}
	else
	{
		m_s3.Format("RVB (%3d, %3d, %3d)",m_sliderR.GetPos(),m_sliderV.GetPos(),m_sliderB.GetPos());	
	}

	if (m_radioType==0)
	{
		//Barres
		m_pDoc->m_lCB=m_sliderR.GetPos()+m_sliderV.GetPos()*256+m_sliderB.GetPos()*65536;
	}
	else
	{
		//Espaces
		m_pDoc->m_lCE=m_sliderR.GetPos()+m_sliderV.GetPos()*256+m_sliderB.GetPos()*65536;
	}
	m_iNb=0;m_OK=TRUE;m_s4="";
	UpdateData(FALSE);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
//________________________________________
void CCouCoDlg::OnRadiob() 
{
	m_radioType=0;
	m_sliderR.SetPos(m_pDoc->m_lCB&255);
	m_sliderV.SetPos((m_pDoc->m_lCB/256)&255);
	m_sliderB.SetPos((m_pDoc->m_lCB/65536)&255);
}
//________________________________________
void CCouCoDlg::OnRadioe() 
{
	m_radioType=1;
	m_sliderR.SetPos(m_pDoc->m_lCE&255);
	m_sliderV.SetPos((m_pDoc->m_lCE/256)&255);
	m_sliderB.SetPos((m_pDoc->m_lCE/65536)&255);
}
//________________________________________
void CCouCoDlg::OnRadiomono() 
{
	//Code monochrome
	m_radioType1=1;
	//Les 3 curseurs sont lis, on les aligne sur le rouge
	m_sliderV.SetPos(m_sliderR.GetPos());
	m_sliderB.SetPos(m_sliderR.GetPos());
}
//________________________________________
void CCouCoDlg::OnRadiocoul() 
{
	//Code couleur
	m_radioType1=0;
}
//________________________________________
void CCouCoDlg::OnTimer(UINT nIDEvent) 
{
	//Mise  jour automatique au bout de 0,5 s aprs dplacement slider
	m_iNb++;
	if (m_iNb>20 && m_OK==TRUE)
	{
		//Mise  jour
		m_OK=FALSE;
		CCode *pCode;
		pCode=new CCode(m_pDoc);
		pCode->Couleur(m_pDoc->m_lCB,m_pDoc->m_lCE);
		pCode->TraceCode(7,60,m_pDoc->m_sCode);
		delete pCode;
		m_pDoc->UpdateAllViews(NULL);
		m_s4="*";
		UpdateData(FALSE);
	}	
	CDialog::OnTimer(nIDEvent);
}
