/*****************************************************************************
 * HComplexImage.h
 ***************************************************************************** 
 *
 * Project:     Halcon/C++
 * Description: Types for Complex-images
 *
 * (c) 1996-2000 by MVTec Software GmbH
 *                  Neherstr. 1, 81675 Muenchen, Germany
 * 
 *****************************************************************************
 *
 * $Revision: 1.9 $
 * $Date: 2000/02/24 16:15:45 $
 *
 */


#ifndef H_COMPLEX_IMAGE_H
#define H_COMPLEX_IMAGE_H



class LIntExport HComplexImage: public HImage {
public:
  HComplexImage(void);
  HComplexImage(const HImage &image);
  HComplexImage(const HComplexImage &image);
  HComplexImage(int width, int height);
  HComplexImage(const float *real, const float *ima, int width, int height);
  HComplexImage(const HFloatImage &real, const HFloatImage &ima,
		int width, int height);
  virtual ~HComplexImage(void);
  
  // Tools
  const char *ClassName(void) const { return "HComplexImage"; }
  const char *InstClassName(void) const { return "HComplexImage"; }
  

  // Pixelzugriff
  HComplex operator[] (long k) const
  { if (!privat) ((HComplexImage*)this)->Private(); return ((HComplex*)ptr)[k]; }
  HComplex &operator[] (long k)
  { if (!init) Init(); return ((HComplex*)ptr)[k]; }
  HComplex &operator()(int x, int y) 
  { if (!init) Init(); return ((HComplex*)ptr)[HLinearCoord(x,y,width)]; }
  HComplex &operator()(long k) 
  { if (!init) Init(); return ((HComplex*)ptr)[k]; }
  void SetPixVal(long k, const HPixVal &val);
    //{ if (!init) Init(); ((HComplex*)ptr)[k] = val; }
  void SetPixVal(int x, int y, const HPixVal &val); 
    //{ if (!init) Init(); ((HComplex*)ptr)[HLinearCoord(x,y,width)] = val; }

  // Klassenoperationen
  static long NumInst(void) { return num_images; }
protected:
private:
  static long num_images;
};


#endif
