/*****************************************************************************
 * HOCV.h
 ***************************************************************************** 
 *
 * Project:     Halcon/C++
 * Description: Class HOCV
 *
 * (c) 1996-2001 by MVTec Software GmbH
 *                  Neherstr. 1, 81675 Muenchen, Germany
 * 
 *****************************************************************************
 *
 * $Revision: 1.4 $
 * $Date: 2003/10/02 09:58:13 $
 *
 */

#ifndef H_OCV_H
#define H_OCV_H

class LIntExport HOCV: public HRootObject {
public:
  HOCV(void) {id = -1;}
  HOCV(const HTuple &PatternName);
  HOCV(const char *PatternName);

  ~HOCV(void);
private:
  // Copying and Assignment not allowed
  HOCV(const HOCV &inst);
  HOCV &operator= (const HOCV &inst);
  // Internal Cleanup
  void Cleanup(void);

public: 
  // Tools
  const char *ClassName(void) const {return "HOCV";}

  // Cast Operator
  operator HTuple () const {return HTuple(GetHandle());}

  // Access and Manipulation
  long GetHandle(void) const {return id;}
  void SetHandle(long ID) {id = ID;}

private:
  // Handle
  long  id;
public:
  // Verification of a pattern using an OCV tool.
  virtual HTuple DoOcvSimple(const HImageArray &Pattern, const HTuple &PatternName, const HTuple &AdaptPos, const HTuple &AdaptSize, const HTuple &AdaptAngle, const HTuple &AdaptGray, const HTuple &Threshold) const;
  virtual HTuple DoOcvSimple(const HImageArray &Pattern, const char *PatternName, const char *AdaptPos, const char *AdaptSize, const char *AdaptAngle, const char *AdaptGray, double Threshold) const;
  // Training of an OCV tool.
  virtual void TraindOcvProj(const HImageArray &Pattern, const HTuple &Name, const HTuple &Mode) const;
  virtual void TraindOcvProj(const HImageArray &Pattern, const char *Name, const char *Mode) const;
  // Reading an OCV tool from file.
  virtual void ReadOcv(const HTuple &FileName);
  virtual void ReadOcv(const char *FileName);
  // Saving an OCV tool to file.
  virtual void WriteOcv(const HTuple &FileName) const;
  virtual void WriteOcv(const char *FileName) const;
  // Create a new OCV tool based on gray value projections.
  virtual void CreateOcvProj(const HTuple &PatternNames);
  virtual void CreateOcvProj(const char *PatternNames);
};

#endif
