/*****************************************************************************
 * HSync.h
 ***************************************************************************** 
 *
 * Project:     Halcon/libhalcon
 * Description: Synchronisation macros for Windows/NT
 *
 * (c) 1996-2000 by MVTec Software GmbH
 *                  Neherstr. 1, 81675 Muenchen, Germany
 * 
 *****************************************************************************
 *
 * $Revision: 1.13 $
 * $Date: 2000/05/17 12:40:07 $
 *
 */


#ifndef _HSYNC_H

/* WIN32 */
#if defined (WIN32)

#include "windows.h"

#if defined(__cplusplus)
extern "C" {
#endif

#if defined (_MAKE_H_THREAD_SAFE) && ! defined (_NODLL)
extern LIntExport CRITICAL_SECTION	csHalcon;
#define H_SYNC_ENTER_CRITICAL_SECTION	EnterCriticalSection(&csHalcon);
#define H_SYNC_LEAVE_CRITICAL_SECTION	LeaveCriticalSection(&csHalcon);
#define H_SYNC_CRITICAL_SECTION_DEF     CRITICAL_SECTION csHalcon;
#else
#define H_SYNC_ENTER_CRITICAL_SECTION
#define H_SYNC_LEAVE_CRITICAL_SECTION
#define H_SYNC_CRITICAL_SECTION_DEF
#endif

#if defined(__cplusplus)
}
#endif
#else  /* end of part WIN32 */

/* SUN Solaris, SGI-Irix, HP-UX (10.30 or higher), Linux: */
#if defined (SGI) || defined(SOLARIS) || defined(HPPA2) || defined(LINUX)

#if defined(__cplusplus)
extern "C" {
#endif

#if defined (_MAKE_H_THREAD_SAFE) && ! defined (_NODLL)
#include "hlib/HCriticalSection.h"
#define H_SYNC_LEAVE_CRITICAL_SECTION  HLeaveCriticalSectionG();
#define H_SYNC_ENTER_CRITICAL_SECTION  HEnterCriticalSectionG();
#define H_SYNC_CRITICAL_SECTION_DEF
#else
#define H_SYNC_LEAVE_CRITICAL_SECTION
#define H_SYNC_ENTER_CRITICAL_SECTION
#define H_SYNC_CRITICAL_SECTION_DEF
#endif

#if defined(__cplusplus)
}
#endif

/* HP-UX 9.xx, DEC and all others: */
#else
#define H_SYNC_LEAVE_CRITICAL_SECTION
#define H_SYNC_ENTER_CRITICAL_SECTION
#define H_SYNC_CRITICAL_SECTION_DEF
#endif

#endif /* end of section: not Windows OS */

#endif /* _HSYNC_H */
