/*****************************************************************************
 * HXLDPara.h
 ***************************************************************************** 
 *
 * Project:     Halcon/libhalcon
 * Description: Class HXLDPara
 *
 * (c) 1996-2001 by MVTec Software GmbH
 *                  Neherstr. 1, 81675 Muenchen, Germany
 * 
 *****************************************************************************
 *
 * $Revision: 1.14 $
 * $Date: 2001/12/06 10:04:06 $
 *
 */

#ifndef XLD_PARA_H
#define XLD_PARA_H


/****************************************************************************/
/*                               HXLDPara                                   */
/****************************************************************************/

class HXLDParaArray;
class LIntExport HXLDPara: public HXLD {
  friend class HXLDParaArray;
public:
  HXLDPara(void): HXLD() {num_para++;}
  HXLDPara(Hkey key);
  HXLDPara(const Hobject &obj);
  HXLDPara(const HXLDPara &para);
  HXLDPara(const HXLDParaArray &arr);
  HXLDPara(const HXLD &xld);
  ~HXLDPara(void) {num_para--;}

  HXLDPara &operator= (const HXLDPara &para);
  HXLDPara &operator= (const HXLDParaArray &arr);
  HXLDPara &operator= (const HXLD &xld);

  // Tools
  virtual const char *HClassName(void) const;
  virtual const char *ClassName(void) const;
  virtual const char *InstClassName(void) const;
  virtual       INT4  ClassDBID(void) const;
  HBool         Shared(void) const;

  // Class Functions
  static long NumInst(void) {return num_para;}

private:
  static long num_para;

public:

};

#endif
