// MultDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "MultDlg.h"
#include "BkDoc.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CMultDlg dialog
CMultDlg::CMultDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMultDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMultDlg)
	m_s1 = _T("");
	//}}AFX_DATA_INIT
}
//________________________________________
void CMultDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMultDlg)
	DDX_Control(pDX, IDC_SLIDER1, m_slider);
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Text(pDX, IDC_STATIC1, m_s1);
	//}}AFX_DATA_MAP
}
//________________________________________
BEGIN_MESSAGE_MAP(CMultDlg, CDialog)
	//{{AFX_MSG_MAP(CMultDlg)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDORI, OnOri)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CMultDlg message handlers
BOOL CMultDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_pApp=((CBkApp*)AfxGetApp());
	//Pointeur sur l'application
	m_pApp=((CBkApp*)AfxGetApp());
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur le document
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	//Pointeur sur la vue
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	GetSize(m_pDoc->image,&m_L,&m_H,&m_channels);

	w_R=new unsigned char[m_L*m_H];
	w_G=new unsigned char[m_L*m_H];
	w_B=new unsigned char[m_L*m_H];
	//Image originale
	copy_image(m_pDoc->image,&imageOri);
	//Dfinition des plages des sliders
	m_slider.SetRange(1,100);
	m_slider.SetPos(10);
	m_fCoef=0.1*(m_slider.GetPos());
	m_s1.Format("Coef [0.1, 10]: %1.1f",m_fCoef);
	UpdateData(FALSE);
	m_iNb=0;m_OK=FALSE;/*m_s4="";*/SetTimer(28,50,NULL);
	return TRUE;
}
//________________________________________
void CMultDlg::OnOK() 
{
	KillTimer(28);
	Visualiser();

	delete w_R;
	delete w_G;
	delete w_B;

	m_pView->Invalidate(TRUE);

	CDialog::OnOK();
}
//________________________________________
void CMultDlg::OnCancel() 
{
	KillTimer(28);
	copy_image(imageOri,&(m_pDoc->image));
	m_pView->Invalidate(TRUE);
	delete w_R;
	delete w_G;
	delete w_B;
	CDialog::OnCancel();
}
//________________________________________
void CMultDlg::GetPixelColor(Hobject image,unsigned char *wR,unsigned char *wG,unsigned char *wB) 
{
	short i,j;
	long l,h,channels;
	char lpcsType[128];
	unsigned char 
		*R,*V,*B;

	count_channels(image,&channels);
	if (channels==1) 
	{
		get_image_pointer1(image,(long*)&R,lpcsType,&l,&h);
		for (i=0;i<l;i++)
		{
			for (j=0;j<h;j++)
			{
				wR[i+j*l]=*(R+i+j*l);
				wG[i+j*l]=*(R+i+j*l);
				wB[i+j*l]=*(R+i+j*l);
			}
		}
	}
	else
	{
		get_image_pointer3(image,(long*)&R,(long*)&V,(long*)&B,lpcsType,&l,&h);
		for (i=0;i<l;i++)
		{
			for (j=0;j<h;j++)
			{
				wR[i+j*l]=*(R+i+j*l);
				wG[i+j*l]=*(V+i+j*l);
				wB[i+j*l]=*(B+i+j*l);
			}
		}
	}
}
//________________________________________
void CMultDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{

	m_fCoef=0.1*(m_slider.GetPos());
	m_s1.Format("Coef [0.1, 10]: %1.1f",m_fCoef);
	UpdateData(FALSE);
	m_iNb=0;m_OK=TRUE;//m_s4="";
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
//________________________________________
void CMultDlg::GetSize(Hobject image,long *L,long *H,long *channels)
{
	char lpcsType[128];
	unsigned char 
		*R,*V,*B;

	count_channels(image,channels);
	if (*channels==1) 
		get_image_pointer1(image,(long*)&R,lpcsType,L,H);
	else
		get_image_pointer3(image,(long*)&R,(long*)&V,(long*)&B,lpcsType,L,H);
}
//________________________________________
void CMultDlg::SetPixelColor(long l,long h,unsigned char *wR,unsigned char *wG,unsigned char *wB,Hobject *image) 
{
	long channels;
	count_channels(*image,&channels);
	if (channels==1) 
		gen_image1(image,"byte",l,h,(long)wR);
	else
		gen_image3(image,"byte",l,h,(long)wR,(long)wG,(long)wB);
}
//________________________________________
void CMultDlg::OnOri() 
{
	m_slider.SetPos(10);
	m_fCoef=0.1*(m_slider.GetPos());
	m_s1.Format("Coef [0.1, 10]: %1.1f",m_fCoef);
	UpdateData(FALSE);
	Visualiser();	
}
//________________________________________
void CMultDlg::Visualiser()
{
	short i,j;
	float r;
	copy_image(imageOri,&(m_pDoc->image));
	GetPixelColor(m_pDoc->image,w_R,w_G,w_B);
	for (i=0;i<m_L;i++)
	{
		for (j=0;j<m_H;j++)
		{
			r=m_fCoef*w_R[i+j*m_L];
			if (r<0) r=0;
			if (r>255) r=255;
			w_R[i+j*m_L]=(unsigned char)r;

			r=m_fCoef*w_G[i+j*m_L];
			if (r<0) r=0;
			if (r>255) r=255;
			w_G[i+j*m_L]=(unsigned char)r;

			r=m_fCoef*w_B[i+j*m_L];
			if (r<0) r=0;
			if (r>255) r=255;
			w_B[i+j*m_L]=(unsigned char)r;
		}
	}
	SetPixelColor(m_L,m_H,w_R,w_G,w_B,&(m_pDoc->image));
	m_pView->Invalidate(TRUE);
}
//________________________________________
/*
void CMultDlg::OnAppliquer1() 
{
	Visualiser();
}
*/
//________________________________________
void CMultDlg::OnTimer(UINT nIDEvent) 
{
	//Mise  jour automatique au bout de __ s aprs dplacement slider
	m_iNb++;
	if (m_iNb>10 && m_OK==TRUE)
	{
		//Mise  jour
		m_OK=FALSE;
		Visualiser();
		m_pDoc->UpdateAllViews(NULL);
		//m_s4="*";
		//UpdateData(FALSE);
	}	
	CDialog::OnTimer(nIDEvent);
}
