// ParNum1Dlg.cpp : implementation file
//Rglages de la camra IEEE1394
#include "stdafx.h"
#include "Bk.h"
#include "ParNum1Dlg.h"
#include "BkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CParNum1Dlg dialog
CParNum1Dlg::CParNum1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CParNum1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CParNum1Dlg)
	m_s8 = _T("");
	m_iShutter = 0;
	m_s9 = _T("");
	m_iGain = 0;
	m_Auto1 = FALSE;
	m_Auto2 = FALSE;
	//}}AFX_DATA_INIT
}
void CParNum1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CParNum1Dlg)
	DDX_Control(pDX, IDC_SLIDER2, m_slider2);
	DDX_Control(pDX, IDC_SLIDER1, m_slider1);
	DDX_Text(pDX, IDC_STATIC8, m_s8);
	DDX_Text(pDX, IDC_SHUTTER, m_iShutter);
	DDX_Text(pDX, IDC_STATIC9, m_s9);
	DDX_Text(pDX, IDC_GAIN, m_iGain);
	DDX_Check(pDX, IDC_CHECK1, m_Auto1);
	DDX_Check(pDX, IDC_CHECK2, m_Auto2);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CParNum1Dlg, CDialog)
	//{{AFX_MSG_MAP(CParNum1Dlg)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CParNum1Dlg message handlers
BOOL CParNum1Dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	HTuple h;
	long l[4];
	short i;	
	m_pApp=((CBkApp*)AfxGetApp());

	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument();
	}
	m_pDoc->AcqPerm();

	get_framegrabber_param(m_pDoc->m_lFGHandle,"shutter_range",&h);
	for (i=0;i<4;i++) l[i]=h[i];
	m_s8.Format("Opturateur [%d, %d]:",l[0],l[1]);
	m_iShutter=l[3];
	m_slider1.SetRange(l[0],l[1]);
	m_slider1.SetPos(l[3]);

	get_framegrabber_param(m_pDoc->m_lFGHandle,"video_gain_range",&h);
	for (i=0;i<4;i++) l[i]=h[i];
	m_s9.Format("Gain [%d, %d]:",l[0],l[1]);
	m_iGain=l[3];
	m_slider2.SetRange(l[0],l[1]);
	m_slider2.SetPos(l[3]);

	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CParNum1Dlg::OnCancel() 
{
	m_pDoc->FigerAcq();
	CDialog::OnCancel();
}
//________________________________________
void CParNum1Dlg::OnOK() 
{
	//Appliquer
	UpdateData(TRUE);
	HTuple h;
	long l[4];
	short i;	
	get_framegrabber_param(m_pDoc->m_lFGHandle,"shutter_range",&h);
	for (i=0;i<4;i++)	l[i]=h[i];
	if (m_iShutter<l[0]) m_iShutter=l[0];
	if (m_iShutter>l[1]) m_iShutter=l[1];
	if (!m_Auto1) 
	{
		set_framegrabber_param(m_pDoc->m_lFGHandle,"shutter",m_iShutter);
		m_slider1.SetPos(m_iShutter);

	}

	get_framegrabber_param(m_pDoc->m_lFGHandle,"video_gain_range",&h);
	for (i=0;i<4;i++)	l[i]=h[i];
	if (m_iGain<l[0]) m_iGain=l[0];
	if (m_iGain>l[1]) m_iGain=l[1];
	if (!m_Auto2)
	{
		set_framegrabber_param(m_pDoc->m_lFGHandle,"video_gain",m_iGain);
		m_slider2.SetPos(m_iGain);
	}

	UpdateData(FALSE);
	//CDialog::OnOK();
}
//________________________________________
void CParNum1Dlg::OnCheck1() 
{
	UpdateData(TRUE);
	if (m_Auto1)
	{
		set_framegrabber_param(m_pDoc->m_lFGHandle,"shutter","auto");
		GetDlgItem(IDC_SHUTTER)->EnableWindow(FALSE);
		GetDlgItem(IDC_SLIDER1)->EnableWindow(FALSE);
	}
	else
	{
		set_framegrabber_param(m_pDoc->m_lFGHandle,"shutter",m_iShutter);
		GetDlgItem(IDC_SHUTTER)->EnableWindow(TRUE);
		GetDlgItem(IDC_SLIDER1)->EnableWindow(TRUE);
	}
}
//________________________________________
void CParNum1Dlg::OnCheck2() 
{
	UpdateData(TRUE);
	if (m_Auto2)
	{
		set_framegrabber_param(m_pDoc->m_lFGHandle,"video_gain","auto");
		GetDlgItem(IDC_GAIN)->EnableWindow(FALSE);
		GetDlgItem(IDC_SLIDER2)->EnableWindow(FALSE);
	}
	else
	{
		set_framegrabber_param(m_pDoc->m_lFGHandle,"video_gain",m_iGain);
		GetDlgItem(IDC_GAIN)->EnableWindow(TRUE);
		GetDlgItem(IDC_SLIDER2)->EnableWindow(TRUE);
	}
}
//________________________________________
void CParNum1Dlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	m_iShutter=m_slider1.GetPos();
	m_iGain=m_slider2.GetPos();
	set_framegrabber_param(m_pDoc->m_lFGHandle,"shutter",m_iShutter);
	set_framegrabber_param(m_pDoc->m_lFGHandle,"video_gain",m_iGain);
	UpdateData(FALSE);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
