//ParNum2Dlg.cpp : implementation file
//Rglages de la camra mvBlueFOX
#include "stdafx.h"
#include "Bk.h"
#include "ParNum2Dlg.h"
#include "BkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CParNum2Dlg dialog
CParNum2Dlg::CParNum2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CParNum2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CParNum2Dlg)
	m_iShutter = 0;
	m_s8 = _T("");
	m_s9 = _T("");
	m_fGain = 0.0f;
	//}}AFX_DATA_INIT
}
void CParNum2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CParNum2Dlg)
	DDX_Control(pDX, IDC_SLIDER2, m_slider2);
	DDX_Control(pDX, IDC_SLIDER1, m_slider1);
	DDX_Text(pDX, IDC_SHUTTER, m_iShutter);
	DDX_Text(pDX, IDC_STATIC8, m_s8);
	DDX_Text(pDX, IDC_STATIC9, m_s9);
	DDX_Text(pDX, IDC_GAIN, m_fGain);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CParNum2Dlg, CDialog)
	//{{AFX_MSG_MAP(CParNum2Dlg)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CParNum2Dlg message handlers
BOOL CParNum2Dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	HTuple h;
	long l[4];
	short i;	
	m_pApp=((CBkApp*)AfxGetApp());

	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument();
	}
	m_pDoc->AcqPerm();

	//Voir Hdevelop : matrixvisionacquire_properties.dev	
	get_framegrabber_param(m_pDoc->m_lFGHandle,"Camera/Expose_us",&h);
	l[0]=h[0];
	m_s8.Format("Opturateur(s) [%d, %d] :",750,20000);
	m_iShutter=l[0];

	m_slider1.SetRange(750,20000);
	m_slider1.SetPos(l[0]);
	
	//On applique un facteur 10 au slider gain
	get_framegrabber_param(m_pDoc->m_lFGHandle,"Camera/Gain_dB",&h);
	l[0]=h[0];
	m_s9.Format("Gain(dB) [%d, %d] :",0,15);
	m_fGain=l[0]*10;
	m_slider2.SetRange(0,150);
	m_slider2.SetPos(l[0]*10);

	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CParNum2Dlg::OnCancel() 
{
	m_pDoc->FigerAcq();
	CDialog::OnCancel();
}
//________________________________________
void CParNum2Dlg::OnOK() 
{
	UpdateData(TRUE);
	if (m_iShutter<750) m_iShutter=750;
	if (m_iShutter>20000) m_iShutter=20000;
	if (m_fGain<0) m_fGain=0;
	if (m_fGain>15) m_fGain=15;

	m_slider1.SetPos(m_iShutter);
	m_slider2.SetPos(m_fGain*10);
	
	set_framegrabber_param(m_pDoc->m_lFGHandle,"Camera/Expose_us",m_iShutter);
	set_framegrabber_param(m_pDoc->m_lFGHandle,"Camera/Gain_dB",m_fGain);

	m_pApp->m_iShutter=m_iShutter;
	m_pApp->m_fGain=m_fGain;

	UpdateData(FALSE);
	//CDialog::OnOK();
}
//________________________________________
void CParNum2Dlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	m_iShutter=m_slider1.GetPos();
	m_fGain=0.1*m_slider2.GetPos();

	set_framegrabber_param(m_pDoc->m_lFGHandle,"Camera/Expose_us",m_iShutter);
	set_framegrabber_param(m_pDoc->m_lFGHandle,"Camera/Gain_dB",m_fGain);
	UpdateData(FALSE);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
