// RedimDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "RedimDlg.h"
#include "BkDoc.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CRedimDlg dialog
CRedimDlg::CRedimDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRedimDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRedimDlg)
	m_s15 = _T("");
	m_s16 = _T("");
	//}}AFX_DATA_INIT
}
void CRedimDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRedimDlg)
	DDX_Control(pDX, IDC_SLIDER_REDIM, m_sliderR);
	DDX_Text(pDX, IDC_STATIC15, m_s15);
	DDX_Text(pDX, IDC_STATIC16, m_s16);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CRedimDlg, CDialog)
	//{{AFX_MSG_MAP(CRedimDlg)
	ON_WM_HSCROLL()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CRedimDlg message handlers
BOOL CRedimDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument();
	}
	//Taille de l'image courante
	m_iL=m_pDoc->m_iL;
	m_iH=m_pDoc->m_iH;
	//On copie l'image courante dans m_imageOri
	copy_image(m_pDoc->image,&m_imageOri);
	//Largeur mini : 150 pixels
	if (m_iL<150) m_iCoefMini=100; else m_iCoefMini=150*100/m_iL;
	if (m_iCoefMini<20) m_iCoefMini=20;

	//On dfinit les paramtres du curseur
	m_sliderR.SetRange(m_iCoefMini,200);//20%  200%
	m_iCoef=100;
	m_sliderR.SetPos(m_iCoef);
	m_sliderR.SetTicFreq(10);
	m_s15.Format("Coef[%d,%d]: %d %%",m_iCoefMini,200,m_iCoef);

	m_s16.Format("Dimensions (pixel): %d x %d\nMini: %d x %d\nMaxi: %d x %d",m_iL,m_iH,m_iL*m_iCoefMini/100,m_iH*m_iCoefMini/100,m_iL*2,m_iH*2);
	UpdateData(FALSE);
	m_iNb=0;m_OK=FALSE;/*m_s4="";*/SetTimer(28,50,NULL);
	return TRUE;
}
//________________________________________
void CRedimDlg::OnOK() 
{
	KillTimer(28);	
	CDialog::OnOK();
}
//________________________________________
void CRedimDlg::OnCancel() 
{
	KillTimer(28);	
	short L,H;
	//Taille initiale
	L=m_iL;
	H=m_iH;
	zoom_image_size(m_imageOri,&(m_pDoc->image),L,H,"constant");

	m_pDoc->m_iL=L;
	m_pDoc->m_iH=H;
	m_pDoc->DimensionnerFenetre(L,H);
	m_pDoc->DefinirCurseurs(L,H);
	m_pDoc->EcritTitre();
	set_window_extents(m_pDoc->m_pView->m_lWindowID,0,0,L,H);

	CDialog::OnCancel();
}
//________________________________________
void CRedimDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	m_iCoef=m_sliderR.GetPos();
	//Dimensionner();
	m_iNb=0;m_OK=TRUE;//m_s4="";
	m_s15.Format("Coef[%d,%d]: %d %%",m_iCoefMini,200,m_iCoef);

	short L=(short)(1.0*m_iCoef*m_iL/100);
	short H=(short)(1.0*m_iCoef*m_iH/100);


	m_s16.Format("Dimensions (pixel): %d x %d\nMini: %d x %d\nMaxi: %d x %d",L,H,m_iL*m_iCoefMini/100,m_iH*m_iCoefMini/100,m_iL*2,m_iH*2);
	UpdateData(FALSE);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
//________________________________________
void CRedimDlg::Dimensionner() 
{
	short L,H;
	//Nouvelle taille de l'image
	L=(short)(1.0*m_iCoef*m_iL/100);
	H=(short)(1.0*m_iCoef*m_iH/100);
	zoom_image_size(m_imageOri,&(m_pDoc->image),L,H,"constant");

	m_pDoc->m_iL=L;
	m_pDoc->m_iH=H;
	m_pDoc->DimensionnerFenetre(L,H);
	m_pDoc->DefinirCurseurs(L,H);
	m_pDoc->EcritTitre();
	set_window_extents(m_pDoc->m_pView->m_lWindowID,0,0,L,H);

	//Suppression profils, tracker, coordonnes
	m_pDoc->m_iDw=-1;
	m_pDoc->m_tracker.m_rect.SetRectEmpty();
	if (m_pDoc->m_iType&4) m_pDoc->m_iType=m_pDoc->m_iType^4;
	//m_pDoc->m_pView->Invalidate(FALSE);
	m_pDoc->m_pView->VisuHalcon();
	m_s15.Format("Coef[%d,%d]: %d %%",m_iCoefMini,200,m_iCoef);
	m_s16.Format("Dimensions (pixel): %d x %d\nMini: %d x %d\nMaxi: %d x %d",L,H,m_iL*m_iCoefMini/100,m_iH*m_iCoefMini/100,m_iL*2,m_iH*2);
	UpdateData(FALSE);
}
//________________________________________
void CRedimDlg::OnTimer(UINT nIDEvent) 
{
	//Mise  jour automatique au bout de 0,5 s aprs dplacement slider
	m_iNb++;
	if (m_iNb>10 && m_OK==TRUE)
	{
		//Mise  jour
		m_OK=FALSE;
		Dimensionner();
	}	
	CDialog::OnTimer(nIDEvent);
}
